package Hero;

import java.io.Serializable;
import java.text.DecimalFormat;
import java.util.Random;
import Tools.*;

public final class Item implements Serializable
{
	private String name; //name of item
	private String mod; // Modifier
	private String category; //Category
	private String itemName; //Final Item Name
	private String effect; //Item Effect
	private int modMovesCalc; //Mod: Moves Calculation
	private String modMovesCalcText;
	private String modChancCalcText;
	private String modPotioCalcText;
	private String itemCode; //String to keep track of and import items.
	private double itemPrice; //Starting price of item.
	private double itemValue; //value of item after use.
	private String passeffect; //the effect of the item to pass to hero.
        private DecimalFormat Currency = new DecimalFormat("$0.00");
	
	RDN itemCat = new RDN(3); //Item Category #4 enable other
	RDN itemAS = new RDN(5);//Anti-status
	RDN torp = new RDN(2); //Temporary or Permanent
	RDN itemPPE = new RDN(4);//Permanent PE
	RDN rareChance = new RDN(8);//Rare Chance
	RDN itemRare = new RDN(4);//Rare Item 
	RDN itemOther = new RDN(1);//Other Item
	RDN itemModifer = new RDN(20);//Item modifier chance, 5 items random number between 0 and 19
        RDN randomPrice = new RDN(20);
	
	private String[] itemCatagory = {"Anti-status", "Point Enhancers", "Rare", "Other"};//4
	private String[] asNames = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion"};//5
	private String[] ppeNames = {"Health", "Attack", "Weapon Health", "Weapon Attack"};//4
	private String[] rareNames = {"Cure All", "Experence Increase", "Weapon Inventory Increase", "Item Inventory Increase"};//3
	private String[] otherNames = {"Repel"};//1
	private String[] modifers = {"Basic", "Super", "Mega", "Ultra", "Hyper"};//5
	private int[] modMoves = {20,40,80,160,320};
	private String[] modMovesText = {"20", "40", "80", "160", "320"};
	private double[] modChanc = {.85,.89,.93,.95,1.0};
	private String[] modChancText = {"85%", "89%", "93%", "95%", "100%"};
	private int[] modPotio = {10,20,40,60,80};
	private String[] modPotioText = {" points", " points", " points", " points", " points"};
	
	public Item(int level)
	{
		int itemCatagoryRDN = itemCat.RN(); 
		int itemASRDN = itemAS.RN();
		int torpRDN = 0;
		int itemPPERDN = itemPPE.RN();
		int itemOtherRDN = itemOther.RN();
		int itemRareRDN = itemRare.RN();
		int rareChanceRDN = rareChance.RN();
		int itemModiferRDN = itemModifer.RN();
                int randomPriceRDN = randomPrice.RN();
		
		if (itemModiferRDN <= 10)
		{
			mod = modifers[0];
			modMovesCalc = modMoves[0];
			modMovesCalcText = modMovesText[0];
			modChancCalcText = modChancText[0];
			modPotioCalcText = (level*modPotio[0]) + modPotioText[0];
			itemCode = "#B#";
			itemPrice = 5.00 + (1 + randomPriceRDN * .4);
                        itemValue = itemPrice;
		}
		if (itemModiferRDN >= 11 && itemModiferRDN <= 13)
		{
			mod = modifers[1];
			modMovesCalc = modMoves[1];
			modMovesCalcText = modMovesText[1];
			modChancCalcText = modChancText[1];
			modPotioCalcText = (level*modPotio[1]) + modPotioText[1];
			itemCode = "#S#";
			itemPrice = 10.50 + (2 + randomPriceRDN * .75);
                        itemValue = itemPrice;
		}
		if (itemModiferRDN >= 14 && itemModiferRDN <= 16)
		{
			mod = modifers[2];
			modMovesCalc = modMoves[2];
			modMovesCalcText = modMovesText[2];
			modChancCalcText = modChancText[2];
			modPotioCalcText = (level*modPotio[2]) + modPotioText[2];
			itemCode = "#M#";
			itemPrice = 16.00 + (3 + randomPriceRDN * .75);
                        itemValue = itemPrice;
		}
		if (itemModiferRDN >= 17 && itemModiferRDN <= 18)
		{
			mod = modifers[3];
			modMovesCalc = modMoves[3];
			modMovesCalcText = modMovesText[3];
			modChancCalcText = modChancText[3];
			modPotioCalcText = (level*modPotio[3]) + modPotioText[3];
			itemCode = "#U#";
			itemPrice = 25.00 + (4 + randomPriceRDN * .75);
                        itemValue = itemPrice;
		}
		if(itemModiferRDN == 19)
		{
			mod = modifers[4];
			modMovesCalc = modMoves[4];
			modMovesCalcText = modMovesText[4];
			modChancCalcText = modChancText[4];
			modPotioCalcText = (level*modPotio[4]) + modPotioText[4];
			itemCode = "#H#";
			itemPrice = 35.00 + (5 + randomPriceRDN * .75);
                        itemValue = itemPrice;
		}
			
              
		switch(itemCatagoryRDN)
		{
			case 0:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "A" + itemCode;
				
				switch(itemASRDN)
				{
					case 0:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "PO";
						effect = "Removes poison effect. " + modChancCalcText + " chance.";
						break;
					}
					case 1:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "BU";
						effect = "Removes burn effect. " + modChancCalcText + " chance.";
						break;
					}
					case 2:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "PA";
						effect = "Removes paralysis effect. " + modChancCalcText + " chance.";
						break;
					}
					case 3:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "SL";
						effect = "Removes sleep effect. " + modChancCalcText + " chance.";
						break;
					}
					case 4:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "CO";
						effect = "Removes confusion effect. " + modChancCalcText + " chance.";
						break;
					}
				}
				name = "Anti-" + name;
				itemName = mod + " " + name;
				break;
			}
			case 1:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "P" + itemCode;
				
				switch(torpRDN)
				{
					case 0:
					{
						switch(itemPPERDN)
						{
							case 0:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "HE" + "#" + level;
								effect = "Restores health by " + modPotioCalcText + ".";
								break;
							}
							case 1:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "AP";
								effect = "Increase attack by " + modPotioCalcText + ".";
								break;
							}
							case 2:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "WH";
								effect = "Restores weapon health by " + modPotioCalcText + ".";
								break;
							}
							case 3:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "WP";
								effect = "Increase weapon attack by " + modPotioCalcText + ".";
								break;
							}
						}
					
						break;
					}
				}
				name = name + " " + "Increase";
				itemName = mod + " " + name;
				break;
			}
			case 2:
			{
				category = itemCatagory[itemCatagoryRDN];
				
			
				if(rareChanceRDN == 1 || rareChanceRDN == 2 || rareChanceRDN == 4)
				{
					itemCode = "R" + itemCode;
					switch(itemRareRDN)
					{
						case 0:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "CA";
							effect = "Removes all negative effects.";
							itemName = mod + " " + name;
							break;
						}
						case 1:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "EI";
							effect = "Increase experence by " + modPotioCalcText + " x10.";
							itemName = mod + " " + name;
							break;
						}
						case 2:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "WII";
							effect = "Increase Weapon Inventory by 1 Slot.";
							itemName = name;
							break;
						}
                                                case 3:
                                                {
                                                        name = rareNames[itemRareRDN];
                                                        itemCode = itemCode + "III";
                                                        effect = "Increase Item Inventory by 1 Slot.";
                                                        itemName = name;
                                                        break;
                                                }
					}
				}
				else if(rareChanceRDN == 0 || rareChanceRDN == 3 || rareChanceRDN == 5 || rareChanceRDN == 6 || rareChanceRDN == 7)
				{
					itemCode = "P" + itemCode;
					name = ppeNames[0] + " Increase";
					itemCode = itemCode + "HE" + "#" + level;
					effect = "Restores health by " + modPotioCalcText + ".";
					itemName = mod + " " + name;
				}
				
				break;
			}
			case 3:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "O" + itemCode;
				
				switch(itemOtherRDN)
				{
					case 0:
					{
						name = otherNames[itemOtherRDN];
						itemCode = itemCode + "RE";
						effect = "Repel attacks for " + modMovesCalcText + " steps.";
						itemName = mod + " " + name;
						break;
					}
				}
				break;
			}
		}
	}
  
	public Item(String ic)
	{
		String[] str_array = ic.split("#");
		String tmpCat = str_array[0];
		String tmpMod = str_array[1];
		String tmpName = str_array[2];
                int level = 0;
                if(str_array[2].equals("HE"))
                {
                    level = Integer.parseInt(str_array[3]);
                }
		double doubleoutput = 0.0;
		int intoutput = 0;
		
		switch(tmpCat)
		{
			case "N":
			{
				setCategory("NULL");
				setName("NULL");
				break;
			}
			case "A":
			{
				
				setCategory("Anti-status");
				switch(tmpName)
				{
					case "PO":
					{
						setName("Poison");
						switch(tmpMod)
						{
							case "B":
							{
								doubleoutput = modChanc[0];
								break;
							}
							case "S":
							{
								doubleoutput = modChanc[1];
								break;
							}
							case "M":
							{
								doubleoutput = modChanc[2];
								break;
							}
							case "U":
							{
								doubleoutput = modChanc[3];
								break;
							}
							case "H":
							{
								doubleoutput = modChanc[4];
								break;
							}
						}
						break;
					}		
			
					case "BU":
					{
						setName("Burn");
						switch(tmpMod)
						{
							case "B":
							{
								doubleoutput = modChanc[0];
								break;
							}
							case "S":
							{
								doubleoutput = modChanc[1];
								break;
							}
							case "M":
							{
								doubleoutput = modChanc[2];
								break;
							}
							case "U":
							{
								doubleoutput = modChanc[3];
								break;
							}
							case "H":
							{
								doubleoutput = modChanc[4];
								break;
							}
						}
						
						break;					
					
					}
					case "PA":
					{
						setName("Paralysis");
						switch(tmpMod)
						{
							case "B":
							{
								doubleoutput = modChanc[0];
								break;
							}
							case "S":
							{
								doubleoutput = modChanc[1];
								break;
							}
							case "M":
							{
								doubleoutput = modChanc[2];
								break;
							}
							case "U":
							{
								doubleoutput = modChanc[3];
								break;
							}
							case "H":
							{
								doubleoutput = modChanc[4];
								break;
							}
						}
						
						break;					
					}
					case "SL":
					{
						setName("Sleep");
						switch(tmpMod)
						{
							case "B":
							{
								doubleoutput = modChanc[0];
								break;
							}
							case "S":
							{
								doubleoutput = modChanc[1];
								break;
							}
							case "M":
							{
								doubleoutput = modChanc[2];
								break;
							}
							case "U":
							{
								doubleoutput = modChanc[3];
								break;
							}
							case "H":
							{
								doubleoutput = modChanc[4];
								break;
							}
						}
						
						break;					
					}
					case "CO":
					{
						setName("Confusion");
						switch(tmpMod)
						{
							case "B":
							{
								doubleoutput = modChanc[0];
								break;
							}
							case "S":
							{
								doubleoutput = modChanc[1];
								break;
							}
							case "M":
							{
								doubleoutput = modChanc[2];
								break;
							}
							case "U":
							{
								doubleoutput = modChanc[3];
								break;
							}
							case "H":
							{
								doubleoutput = modChanc[4];
								break;
							}
						}
						break;					
                                            }
					}
					Random r = new Random();
					Float chance1 = r.nextFloat();
					if (chance1 <= doubleoutput)
					{
						passeffect = "TRUE";
					}
					else
					{
						passeffect = "FALSE";
					}
				break;
			}
                            
			case "P":
			{	
				setCategory("Point Enhancers");
				switch(tmpName)
				{
					case "HE":
					{
						switch(tmpMod)
						{
							case "B":
							{
								intoutput = modPotio[0]  * level;
								break;
							}
							case "S":
							{
								intoutput = modPotio[1]  * level;
								break;
							}
							case "M":
							{
								intoutput = modPotio[2] * level;
								break;
							}
							case "U":
							{
								intoutput = modPotio[3] * level;
								break;
							}
							case "H":
							{
								intoutput = modPotio[4] * level;
								break;
							}
						}
						passeffect = Integer.toString(intoutput);
						setName("Potion");
						break;
					}
					case "AP":
					{
						switch(tmpMod)
						{
							case "B":
							{
								intoutput = modPotio[0];
								break;
							}
							case "S":
							{
								intoutput = modPotio[1];
								break;
							}
							case "M":
							{
								intoutput = modPotio[2];
								break;
							}
							case "U":
							{
								intoutput = modPotio[3];
								break;
							}
							case "H":
							{
								intoutput = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(intoutput);
						setName("Attack");
						break;
					}
					case "WH":
					{
						switch(tmpMod)
						{
							case "B":
							{
								intoutput = modPotio[0];
								break;
							}
							case "S":
							{
								intoutput = modPotio[1];
								break;
							}
							case "M":
							{
								intoutput = modPotio[2];
								break;
							}
							case "U":
							{
								intoutput = modPotio[3];
								break;
							}
							case "H":
							{
								intoutput = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(intoutput);
						setName("WeaponHealth");
						break;
					}
					case "WP":
					{
						switch(tmpMod)
						{
							case "B":
							{
								intoutput = modPotio[0];
								break;
							}
							case "S":
							{
								intoutput = modPotio[1];
								break;
							}
							case "M":
							{
								intoutput = modPotio[2];
								break;
							}
							case "U":
							{
								intoutput = modPotio[3];
								break;
							}
							case "H":
							{
								intoutput = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(intoutput);
						setName("WeaponAttack");
						break;
					}
				}								
				break;
			}
                            
			case "R":
			{
				setCategory("Rare");
                                switch (tmpName)
                                {
                                    case "CA":
                                    {    
                                        switch(tmpMod)
                                        {
                                              case "B":
                                              {
                                                        doubleoutput = modChanc[0] + .35;
                                                        break;
                                                }
                                                case "S":
                                                {
                                                        doubleoutput = modChanc[1] + .20;
                                                        break;
                                                }
                                                case "M":
                                                {
                                                        doubleoutput = modChanc[2] + .10;
                                                        break;
                                                }
                                                case "U":
                                                {
                                                        doubleoutput = modChanc[3];
                                                        break;
                                                }
                                                case "H":
                                                {
                                                        doubleoutput = modChanc[4];
                                                        break;
                                                }
                                        }
                                        Random r = new Random();
					Float chance1 = r.nextFloat();
					if (chance1 <= doubleoutput)
					{
						passeffect = "TRUE";
					}
					else
					{
						passeffect = "FALSE";
					}
                                            setName("CureAll");
                                            break;
                                    }
                                    case "EI":
                                    {    
                                        switch(tmpMod)
                                        {
                                              case "B":
                                              {
                                                        intoutput = modPotio[0] * 10;
                                                        break;
                                                }
                                                case "S":
                                                {
                                                        intoutput = modPotio[1] *10;
                                                        break;
                                                }
                                                case "M":
                                                {
                                                        intoutput = modPotio[2]*10;
                                                        break;
                                                }
                                                case "U":
                                                {
                                                        intoutput = modPotio[3]*10;
                                                        break;
                                                }
                                                case "H":
                                                {
                                                        intoutput = modPotio[4]*10;
                                                        break;
                                                }
                                        }
                                            passeffect = Integer.toString(intoutput);
                                            setName("ExpIncrease");
                                            break;
                                    }
                                    case "WII":
                                    {    
                                        setName("WeaponInventoryIncrease");
                                        passeffect = Integer.toString(1);         
                                        break;
                                    }
                                    case "III":
                                    {
                                        setName("ItemInventoryIncrease");
                                        passeffect = Integer.toString(1);
                                        break;
                                    }
                                }
				break;
			}
			case "O":
			{				
				setCategory("Other");
				passeffect = "NO EFFECT YET";
				break;
			}
		}
		
	}
        
        public Item()
        {
            itemName = "Out of Stock";
            passeffect = " ";
            effect = " ";
            itemValue = 10000000;
            itemPrice = 10000000;
            itemCode = "N#N#N#0";
        }

	public void setName (String n)
	{
		name = n;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setPassEffect(String pe)
	{
		passeffect = pe;
	}
	
	public String getPassEffect()
	{
		return passeffect;
	}
	
	public String getAnyCurrency(double m)
        {
            return (Currency.format(m));
        }
        
	public void setMod (String m)
	{
		mod = m;
	}
	
	public String getMod()
	{
		return mod;
	}
	
	public void setCategory(String c)
	{
		category = c;
	}
	
	public String getCategory()
	{
		return category;
	}
	
	public String getItemName()
	{
		return itemName;
	}
		
	public void setEffect(String e)
	{
		effect = e;
	}
	
	public String getEffect()
	{
		return effect;
	}
	
	public void setMoves(int m)
	{
		modMovesCalc = m;
	}
	
	public int getMoves()
	{
		return modMovesCalc;
	}
	
	public void setIC(String ic)
	{
		itemCode = ic;
	}
	
	public String getIC()
	{
		return itemCode;
	}
	public double getPrice()
	{
		return itemPrice;
	}
	public double getValue()
	{
		return itemValue;
	}
	public void setPrice(double p)
	{
		itemPrice = p;
	}
	public void setValue(double v)
	{
		itemValue = v;
	}
	
	public String getItemStats()
	{
		return("Item: " + itemName + "\nItem Effect: " + effect);
	}
	
	public String displayStoreItems()
	{
		return("Item Name:\n" + itemName + "\n\nItem Description:\n" + effect + "\n\nItem Price:\n" + getAnyCurrency(itemPrice));
	}
}