package Menus;

import java.text.DecimalFormat;
import javax.swing.JOptionPane;
import Hero.*;
import Tools.*;

public class Battle extends javax.swing.JFrame 
{
    private boolean getExp;
    private final int hLevel;  
    private final Hero h;
    private final Enemy e;
    private int enemyStartHealth;
    
    public Battle(Hero hl) 
    { 
        initComponents(); 
        hLevel = hl.getLevel();               
        Enemy e1 = new Enemy(hLevel);
        e = e1;   
        h = hl;
        enemyStartHealth = e1.getHealth();
        updateDisplay();
    }
    
    public final void updateDisplay()
    {
        heroStatsArea.setText(h.getHeroStats());
        weaponArea.setText(h.displayCurrentWeapon());
        enemyArea.setText(e.getStats());
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        heroStats = new javax.swing.JPanel();
        heroStatsScroll = new javax.swing.JScrollPane();
        heroStatsArea = new javax.swing.JTextArea();
        battleLogPanel = new javax.swing.JPanel();
        battleLogScroll = new javax.swing.JScrollPane();
        battleLogArea = new javax.swing.JTextArea();
        enemyPanel = new javax.swing.JPanel();
        enemyScroll = new javax.swing.JScrollPane();
        enemyArea = new javax.swing.JTextArea();
        weaponPanel = new javax.swing.JPanel();
        weaponScroll = new javax.swing.JScrollPane();
        weaponArea = new javax.swing.JTextArea();
        actionPanel = new javax.swing.JPanel();
        attackFists = new javax.swing.JButton();
        attackWeapon = new javax.swing.JButton();
        checkInventory = new javax.swing.JButton();
        tryToEscape = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Battle - Legend of the Secret");
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        heroStats.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));

        heroStatsArea.setEditable(false);
        heroStatsArea.setColumns(20);
        heroStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStatsArea.setRows(5);
        heroStatsScroll.setViewportView(heroStatsArea);

        javax.swing.GroupLayout heroStatsLayout = new javax.swing.GroupLayout(heroStats);
        heroStats.setLayout(heroStatsLayout);
        heroStatsLayout.setHorizontalGroup(
            heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 244, Short.MAX_VALUE)
            .addGroup(heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        heroStatsLayout.setVerticalGroup(
            heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 219, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        battleLogPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Battle Log"));

        battleLogArea.setEditable(false);
        battleLogArea.setColumns(20);
        battleLogArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        battleLogArea.setLineWrap(true);
        battleLogArea.setRows(5);
        battleLogScroll.setViewportView(battleLogArea);

        javax.swing.GroupLayout battleLogPanelLayout = new javax.swing.GroupLayout(battleLogPanel);
        battleLogPanel.setLayout(battleLogPanelLayout);
        battleLogPanelLayout.setHorizontalGroup(
            battleLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(battleLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(battleLogScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        battleLogPanelLayout.setVerticalGroup(
            battleLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(battleLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(battleLogScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)
                .addContainerGap())
        );

        enemyPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Enemy Stats"));

        enemyArea.setEditable(false);
        enemyArea.setColumns(20);
        enemyArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        enemyArea.setRows(5);
        enemyScroll.setViewportView(enemyArea);

        javax.swing.GroupLayout enemyPanelLayout = new javax.swing.GroupLayout(enemyPanel);
        enemyPanel.setLayout(enemyPanelLayout);
        enemyPanelLayout.setHorizontalGroup(
            enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(enemyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(enemyScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                .addContainerGap())
        );
        enemyPanelLayout.setVerticalGroup(
            enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(enemyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(enemyScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 138, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        weaponPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Stats"));

        weaponArea.setEditable(false);
        weaponArea.setColumns(20);
        weaponArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        weaponArea.setRows(5);
        weaponScroll.setViewportView(weaponArea);

        javax.swing.GroupLayout weaponPanelLayout = new javax.swing.GroupLayout(weaponPanel);
        weaponPanel.setLayout(weaponPanelLayout);
        weaponPanelLayout.setHorizontalGroup(
            weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 223, Short.MAX_VALUE)
            .addGroup(weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 203, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponPanelLayout.setVerticalGroup(
            weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        actionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        attackFists.setText("Attack with Fists");
        attackFists.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                attackFistsActionPerformed(evt);
            }
        });

        attackWeapon.setText("Attack with Weapon");
        attackWeapon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                attackWeaponActionPerformed(evt);
            }
        });

        checkInventory.setText("Check Inventory");
        checkInventory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkInventoryActionPerformed(evt);
            }
        });

        tryToEscape.setText("Try to escape");
        tryToEscape.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tryToEscapeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout actionPanelLayout = new javax.swing.GroupLayout(actionPanel);
        actionPanel.setLayout(actionPanelLayout);
        actionPanelLayout.setHorizontalGroup(
            actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(attackWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(attackFists, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(tryToEscape, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(checkInventory, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        actionPanelLayout.setVerticalGroup(
            actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(attackFists)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(attackWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(tryToEscape)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(checkInventory)
                .addGap(17, 17, 17))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(battleLogPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(weaponPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(actionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(heroStats, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(enemyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(heroStats, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(battleLogPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(weaponPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(enemyPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(actionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void attackFistsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackFistsActionPerformed
       
       RDN randomHero = new RDN(15);
       RDN randomEnemy = new RDN(15);
       
       int randomPoison = randomHero.RN() + (2 * h.getLevel());
       int randomHeroAttack = randomHero.RN() + h.getAttack();
       e.setAttack(e.getAttack() + randomEnemy.RN() + 10 - h.getDefense() + (h.getLevel() * 2));
       int paralyzeChanceRDN = randomHero.RN();
       
       if(e.getAttack() <= 9)
       {
           e.setAttack(10);
       }
       updateDisplay();
       switch(h.getStatus())
       {
           case "Normal":
           {
                battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");
                battleLogArea.append("\n");
                break;
           }
           case "Poison":
           {
                battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                battleLogArea.append("\n" + "You are poisoned. You lose an additonal " + randomPoison + " points of health.");
                h.setHealth(h.getHealth() - randomPoison);
                battleLogArea.append("\n");
                break;
           }
           case "Burn":
           {
                battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                battleLogArea.append("\n" + "You are burned. You lose an additonal " + randomPoison + " points of health.");
                h.setHealth(h.getHealth() - randomPoison);
                battleLogArea.append("\n");
                break;
           }
           case "Paralyze":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are paralyzed. You cannot attack.");
                }
                else
                {
                    battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                battleLogArea.append("\n");
                break;
           }
           case "Sleep":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are asleep. You cannot attack.");
                }
                else
                {
                    battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                battleLogArea.append("\n");
                break;
           }
           case "Confusion":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are confused. You have hurt yourself in confusion. You loose an additional " + randomPoison + " points of health.");
                    h.setHealth(h.getHealth() - randomPoison);
                }
                else
                {
                    battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                battleLogArea.append("\n");
                break;
           }
       }
       
       if (h.getStatus().equals("Normal"))
       {
           RDN r2 = new RDN(6);//random status
           RDN r3 = new RDN(50);//chance to do random status
           int tempstatus;
           int temprdstatus;
           tempstatus = r2.sRN();
           temprdstatus = r3.sRN();
           String[] statuslist = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion", "Normal"};
           String status = statuslist[tempstatus];
           if (temprdstatus > 35)
           {
               h.setStatus(status);
               String sMessage;
               if(!status.equals("Normal"))
               {
               sMessage = "You have been hurt by the enemy.\n Your status is: " + "\n" + h.getStatus();
               JOptionPane.showMessageDialog(null, sMessage);
               }
           }    
       }
       
       getExp = true;

       if((e.getHealth() <= 0 && h.getHealth() >= 0) || (h.getHealth() <= 0))
       {
             boolean lose = false;
                 if(h.getHealth() <= 0)
                 {
                     lose = true;
                 }
                 win(lose);
       }
       updateDisplay();
    }//GEN-LAST:event_attackFistsActionPerformed

    private void attackWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackWeaponActionPerformed
        
        if(h.getWeaponInventorySize() != 0)
        {
            Weapon w = h.getWeaponObject(0);
            RDN r2 = new RDN(6);
            int decWepHlth = r2.sRN();  
            
            int weaponstatchg = w.getHealth() - decWepHlth;      
             
            RDN randomHero = new RDN(15);
            RDN randomEnemy = new RDN(15);

            int randomPoison = randomHero.RN() + (2 * h.getLevel());
            int randomHeroAttack = randomHero.RN() + h.getTotalAttack();
            e.setAttack(e.getAttack() + randomEnemy.RN() + (h.getLevel() * 2));
            int paralyzeChanceRDN = randomHero.sRN();

            if(e.getAttack() <= 9)
            {
                e.setAttack(10);
            }
            updateDisplay();
            //if(w.getHealth() >= 0)
            {
                w.setHealth(w.getHealth() - decWepHlth); 
                switch(h.getStatus())
                {
                    case "Normal":
                    {
                        battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");
                        battleLogArea.append("\n");
                        break;
                   }
                   case "Poison":
                   {
                        battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        battleLogArea.append("\n" + "You are poisoned. You lose an additonal " + randomPoison + " points of health.");
                        h.setHealth(h.getHealth() - randomPoison);
                        battleLogArea.append("\n");
                        break;
                   }
                   case "Burn":
                   {
                        battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        battleLogArea.append("\n" + "You are burned. You lose an additonal " + randomPoison + " points of health.");
                        h.setHealth(h.getHealth() - randomPoison);
                        battleLogArea.append("\n");
                        break;
                   }
                   case "Paralyze":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            battleLogArea.append("\n" + "You are paralyzed. You cannot attack.");
                        }
                        else
                        {
                            battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        battleLogArea.append("\n");
                        break;
                   }
                   case "Sleep":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            battleLogArea.append("\n" + "You are asleep. You cannot attack.");
                        }
                        else
                        {
                            battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        battleLogArea.append("\n");
                        break;
                   }
                   case "Confusion":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            battleLogArea.append("\n" + "You are confused. You have hurt yourself in confusion. You loose an additional " + randomPoison + " points of health.");
                            h.setHealth(h.getHealth() - randomPoison);
                        }
                        else
                        {
                            battleLogArea.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            battleLogArea.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        battleLogArea.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        battleLogArea.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        battleLogArea.append("\n");
                        break;
                   }
               }

                if (h.getStatus().equals("Normal"))
                {
                    RDN r4 = new RDN(6);//random status
                    RDN r3 = new RDN(50);//chance to do random status
                    int tempstatus;
                    int temprdstatus;
                    tempstatus = r4.RN();
                    temprdstatus = r3.RN();
                    String[] statuslist = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion", "Normal"};
                    String status = statuslist[tempstatus];
                    if (temprdstatus > 35)
                    {
                        h.setStatus(status);
                        String sMessage;
                        if(!status.equals("Normal"))
                        {
                        sMessage = "You have been hurt by the enemy.\n Your status is: " + "\n" + h.getStatus();
                        JOptionPane.showMessageDialog(null, sMessage);
                        }
                    }    
                }
                w.setHealth(weaponstatchg);
                h.setWeaponObject(0,w);
                getExp = true;
             }
        }
        else
        {
            JOptionPane.showMessageDialog(null, "You do not have a weapon. Either attack with your fists or try to escape.");
        }

        if((e.getHealth() <= 0 && h.getHealth() >= 0) || (h.getHealth() <= 0))
             {
                 boolean lose = false;
                 if(h.getHealth() <= 0)
                 {
                     lose = true;
                 }
                 win(lose);
             }    
       updateDisplay();
       

    }//GEN-LAST:event_attackWeaponActionPerformed

    private void tryToEscapeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tryToEscapeActionPerformed
       getExp = false;
       RDN es = new RDN(11);
       int escape = es.RN();
       int newhealth;
       newhealth = e.getHealth() + escape;
       if (escape % 2 == 0)
       {
            e.setHealth(-5);
            JOptionPane.showMessageDialog(null,"You have successfully escaped...");
            enemyStartHealth = 0;
            Battle.this.dispose();
            Explore eg = new Explore(h);
            eg.setLocationRelativeTo(null);
            eg.setVisible(true);
       }
       else
       {
           JOptionPane.showMessageDialog(null,"Escape attempt failed...");
           e.setHealth(newhealth);
       }
       
    }//GEN-LAST:event_tryToEscapeActionPerformed

    private void checkInventoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkInventoryActionPerformed
       Inventory ig = new Inventory(h);
              ig.setLocationRelativeTo(null);
              ig.setVisible(true);
    }//GEN-LAST:event_checkInventoryActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       updateDisplay();
    }//GEN-LAST:event_formWindowGainedFocus

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
       int result = JOptionPane.showConfirmDialog(null,"Are you sure you want to quit. If you click, \nYES, the game will end... WITHOUT SAVING. \n You must finish the battle to be able to save and quit.","Quit?", JOptionPane.YES_NO_OPTION);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
    }//GEN-LAST:event_formWindowClosing
    
    public void win(boolean lose)
    {
        int ehealth = e.getHealth();
        
        if (ehealth <= 0)
        {
             //JOptionPane.showMessageDialog(null, "The enemy is dead.");
             if (getExp == true && lose == false)
             {
                 int expold = h.getExp();
                 RDN rExp = new RDN(3);
                 int rdExp = rExp.RN();
                 int expchange = enemyStartHealth * (rdExp + 1);
                 int expnew = expold + expchange;
                 h.setExp(expchange);
                 String eMessage1 = "The enemy is dead." + "\n\nYou have gained " + expchange + " points of experience." + "\n" + "Your current exp is now at: " + expnew;
                 //JOptionPane.showMessageDialog(null, eMessage1);
                 Item item = new Item(h.getLevel());
                 eMessage1 = eMessage1 + "\n\nThe enemy dropped an item.";
//                 JOptionPane.showMessageDialog(null, iMessage1);                
                 eMessage1 = eMessage1 + "\n" + h.addItem(item);
//                 JOptionPane.showMessageDialog(null, iMessage1); 
//                 RDN rCash = new RDN(10);
//                 int rdCash = rCash.RN(); 
                 double mMess = Math.abs((h.getLevel() * .7) + (enemyStartHealth * .5));
                 eMessage1 = eMessage1 + "\n\nYou have also recieved " + h.displayCurrency(mMess);
                 JOptionPane.showMessageDialog(null,eMessage1);
                 h.setMoney((h.getMoney()) + (h.getLevel() * .7) + (enemyStartHealth * .5));   
                 h.setTravels(h.getTravels() + " and won!!"+"\n-----------------------------------------\n");
                 Battle.this.dispose();
                 Explore eg = new Explore(h);
                 eg.setLocationRelativeTo(null);
                 eg.setVisible(true);
             }
        }
        if(h.getHealth() <= 0 && lose == true)
        { 
               JOptionPane.showMessageDialog(null, "You are dead");               
               h.setExp(-50);
               double losemoney = h.getMoney();
               double moneydec = losemoney * .25;
               losemoney = losemoney - moneydec;
               if (losemoney <= 0)
               {
                   losemoney = 0;
               }
               h.setMoney(losemoney);
               h.setHealth(((int)h.getDefaultHealth()/2) + 100);
               DecimalFormat currency = new DecimalFormat("$0.00");
               String dMessage = "You have lost " + currency.format(moneydec) + "\n" + "You have also lost 50 exp." + "\n" + "Your health has been reset to " + h.getHealth() + ".";
               JOptionPane.showMessageDialog(null, dMessage);
               h.setTravels(h.getTravels() + " and lost..."+"\n-----------------------------------------\n");
               Battle.this.dispose();
               Explore eg = new Explore(h);
               eg.setLocationRelativeTo(null);
               eg.setVisible(true);
        }                              
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel actionPanel;
    private javax.swing.JButton attackFists;
    private javax.swing.JButton attackWeapon;
    private javax.swing.JTextArea battleLogArea;
    private javax.swing.JPanel battleLogPanel;
    private javax.swing.JScrollPane battleLogScroll;
    private javax.swing.JButton checkInventory;
    private javax.swing.JTextArea enemyArea;
    private javax.swing.JPanel enemyPanel;
    private javax.swing.JScrollPane enemyScroll;
    private javax.swing.JPanel heroStats;
    private javax.swing.JTextArea heroStatsArea;
    private javax.swing.JScrollPane heroStatsScroll;
    private javax.swing.JButton tryToEscape;
    private javax.swing.JTextArea weaponArea;
    private javax.swing.JPanel weaponPanel;
    private javax.swing.JScrollPane weaponScroll;
    // End of variables declaration//GEN-END:variables
}
