package Hero;

import Items.Item;
import Weapons.Weapon;
import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import Places.*;
import Tools.DisplayFormat;
import Tools.ErrorLog;
import java.awt.Point;

public final class Hero implements Serializable
{
    //<editor-fold defaultstate="collapsed" desc="Basic Variables">
    private String heroName;    
    private double heroMoney;
    private int heroExp;
    private int heroLevel;
    private File filelocation;
    private String heroStatus;
    //private int heroArmor;
    ErrorLog el = new ErrorLog();
    //</editor-fold>
      
    //<editor-fold defaultstate="collapsed" desc="Leveling Up System Variables">
    Level levelSystem = new Level();
    private int heroAttack;
    private int heroAttackBonus;
    private int heroHealth;
    private int heroHealthBonus;
    public int heroDefaultHealth;
    private int weaponInventorySlots = 0;
    private int weaponInventoryBonus;
    private int itemInventorySlots = 0;
    private int itemInventoryBonus;
    private int nextExp;
    private int nextLevel;
    private int[] currentLevel;
    private int[] expRequirement;
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Inventory Variables">
    private int weaponInventoryCounter = 5;
    private int itemInventoryCounter = 4;
    private final ArrayList<Weapon> weaponInventory = new ArrayList<>();
    private final ArrayList<Item> itemInventory = new ArrayList<>();
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Location Stuff">
    private Locations loc = new Locations();
    ArrayList<LocationConverter> locationList = loc.getLocationList();
    private int[][] mapData;
    private Point heroLocation;
    private String heroCityName;
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Store Variables">
    private final ArrayList<Weapon> storeWeapons = new ArrayList<>();
    private final ArrayList<Item> storeItems = new ArrayList<>();
    private int storestock;
    //</editor-fold>
    
    public Hero()
    {
        setHeroName("");
        setHeroMoney(25.00);
        setHeroExp(0);
        setHeroLevel(1);
        setHeroStatus("Normal");
        setPlaceWithName("Bluespring Village");
        storestock = 3;
    }
    
    //<editor-fold defaultstate="collapsed" desc="Basic Gets and Sets">
    
    //<editor-fold defaultstate="collapsed" desc="Name">
    public void setHeroName(String name)
    {
        heroName = name;
    }
    
    public String getHeroName()
    {
        return heroName;
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Money">
    public void setHeroMoney(double money)
    {
        heroMoney = money;
    }
    
    public double getHeroMoney()
    {
        return heroMoney;
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Health and Attack">
    public int getHeroHealth()
    {
        return heroHealth + heroHealthBonus;
    }
    
    public void setHeroHealth(int health)
    {
        heroHealth = health;
    }
    
    public String getHeroStatus()
    {
        return heroStatus;
    }
    
    public void setHeroStatus(String stats)
    {
        heroStatus = stats;
    }
    
    public int getHeroAttack()
    {
        return heroAttack + heroAttackBonus;
    }
    
    public void setHeroAttackBonus(int bonus)
    {
        heroAttackBonus =+ bonus;
    }
    
    public void setHeroHealthBonus(int bonus)
    {
        heroHealthBonus =+ bonus;
        
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Weapon">
    public int getWeaponInventorySlots()
    {
        return weaponInventorySlots;
    }
    
    public void setWeaponInventoryBonus(int bonus)
    {
        weaponInventoryBonus =+ bonus;
    }
    
    public void setStartClass(String hClass)
    {
        Weapon w;
        
        switch(hClass)
        {
            case "Warrior":
            {
                w = new Weapon("Wooden Longsword", 12, 100, 10.00);   
                break;
            }
            case "Mage":
            {
                w = new Weapon("Pine Staff", 12, 100, 10.00);   
                break;
            }
            case "Rouge":
            {
                w = new Weapon("Wooden Dagger", 12, 100, 10.00);   
                break;
            }
            default:
            {
                w = new Weapon("CLASS FAILED", 0, 0, 0);
            }
            
            
        }
        getWeaponInventory().add(w);
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Item">
    public int getItemInventorySlots()
    {
        return itemInventorySlots;
    }
    
    public void setItemInventoryBonus(int bonus)
    {
        itemInventoryBonus =+ bonus;
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="File Management">
    public void setFileLocation(File fl)
    {
        filelocation = fl;
    }
    
    public File getFileLocation()
    {
        return filelocation;
    }
    //</editor-fold>
    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Leveling Up">
    public void setHeroExp(int exp)
    {
       if(exp >= nextExp)
       {
           setHeroLevel(nextLevel);
           heroExp = 0;
       }
       else
       {
           heroExp =+ exp;
       }
    }
    
    public int getHeroExp()
    {
        return heroExp;
    }
    
    public void setHeroLevel(int level)
    {
        heroLevel = level;
        currentLevel = levelSystem.getCurrentLevelArray(heroLevel);
        heroAttack = heroAttackBonus + currentLevel[0];
        heroHealth = heroHealthBonus + currentLevel[1];
        heroDefaultHealth = heroHealthBonus + currentLevel[1];
        weaponInventorySlots = weaponInventoryBonus + currentLevel[2];
        weaponInventoryCounter = weaponInventoryCounter + weaponInventoryBonus + 1;
        itemInventorySlots = itemInventoryBonus + currentLevel[3];
        itemInventoryCounter = itemInventoryBonus + itemInventoryCounter + 2;
        setExpRequirement(level);
    }
    
    public void setExpRequirement(int level)
    {
        expRequirement = levelSystem.getExpRequirement(heroLevel);
        nextExp = expRequirement[0];
        nextLevel = expRequirement[1];
    }
    
    public int getNumberOfLevels()
    {
        return levelSystem.getNumberOfLevels();
    }
    
    public int getHeroLevel()
    {
        return heroLevel;
    }
    
    public int getHeroDefaultHealth()
    {
        return heroDefaultHealth;
    }
    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Display Methods">   
    public String displayHeroStats()
    {
        DisplayFormat df = new DisplayFormat();
        return("Name: " + heroName + "\n" + "Health: " + heroHealth + "\n" + "Attack: " + heroAttack + "\n" + "Status: " + heroStatus + "\n" + "Exp: " + heroExp + "\n" + "Level: " + heroLevel + "\n" + "Money: " + df.formatCurrency(heroMoney));
    }
    
    public String displayCurrentWeapon()
    {
        String finalmessage;
        try
        {
           Weapon w2 = getWeaponInventory().get(0);          
           finalmessage = w2.toString();
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = "You have no weapons. \nPurchase a new one \nfrom the store.";
           // el.doErrorLog(ioobe.getStackTrace());
        }
       return finalmessage;
    }
    //</editor-fold>
     
    //<editor-fold defaultstate="collapsed" desc="Weapon Inventory">
    public String addWeapon(Weapon w)
    {
        String finalmessage;
        if(weaponInventory.size() <= weaponInventorySlots)
        {
            weaponInventory.add(w);
            finalmessage = "A weapon with the stats:\n" + w.toString() + "\nHas been added to your inventory.";
            weaponInventoryCounter = weaponInventoryCounter - 1;
            //weaponInventorySlots = weaponInventorySlots - 1;
        }
        else
        {
            finalmessage = "Inventory Full";
        }    
        
        if(!finalmessage.equals("Inventory Full"))
        {
            finalmessage += "\n You now have " + weaponInventoryCounter + " slots left.";
        }
        
        return finalmessage;
    }
    public void destroyWeapon(int i)
    {
        getWeaponInventory().remove(i);
        weaponInventoryCounter = getWeaponInventoryCounter() + 1;
        JOptionPane.showMessageDialog(null, "Weapon Removed.");
    }
    
    public void repairWeapon()
    {
        try
        {
            Weapon w = getWeaponInventory().get(0);
            String repair = w.repairWeapon(heroLevel);
            JOptionPane.showMessageDialog(null, repair);
            if (w.getWeaponHealth() <= 0)
            {
                JOptionPane.showMessageDialog(null, "The weapon will now be removed from your inventory.");
                destroyWeapon(0);
            }
            else
            {
                getWeaponInventory().set(0, w);
            }
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            JOptionPane.showMessageDialog(null, "You have no weapons to repair.");
           // el.doErrorLog(ioobe.getStackTrace());
        }
    }
    
    public String switchWeapon(int i)
    {
        String message;
        try
        {
            Weapon w1 = getWeaponInventory().get(0);
            Weapon w2 = getWeaponInventory().get(i);
            getWeaponInventory().set(0,w2);
            getWeaponInventory().set(i,w1);
            message = "Switch Successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon in that slot. Please choose another number.";
           // el.doErrorLog(ioobe.getStackTrace());
        }
        return message;
    }
    public int getWeaponInventoryCounter()
    {
        return weaponInventoryCounter;
    }

    public ArrayList<Weapon> getWeaponInventory()
    {
        return weaponInventory;
    }
    public ArrayList<Weapon> getStoreWeapons()
    {
        return storeWeapons;
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Item Inventory">
    public String addItem(Item i)
    {
        String finalmessage;
        if(getItemInventory().size() < itemInventorySlots)
        {
            getItemInventory().add(i);
            finalmessage = "An item with the stats:\n" + i.toString() + "\nHas been added to your inventory.";
            itemInventoryCounter = itemInventoryCounter - 1;
        }
        else
        {
            finalmessage = "Inventory Full";
        }
        
        if(!finalmessage.equals("Inventory Full"))
        {
            finalmessage += "\n You now have " + itemInventoryCounter + " slots left.";
        }
        return finalmessage;
    }
    
    public void destroyItem(int i)
    {
        getItemInventory().remove(i);
        itemInventoryCounter = getItemInventoryCounter() + 1;
        JOptionPane.showMessageDialog(null, "Item Removed.");
    }
    
    public void upgradeWeaponHealth(int wh)
    {
        String message;
        try
        {
            Weapon w = weaponInventory.get(0);
            w.setWeaponHealth(w.getWeaponHealth() + wh);
            weaponInventory.set(0,w);
            
            message = "Health increase successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon equipped. Please purchase a weapon.";
            //el.doErrorLog(ioobe.getStackTrace());
        }
        JOptionPane.showMessageDialog(null,message);
    }
    
    public void upgradeWeaponAttack(int wa)
    {
        String message;
        try
        {
            Weapon w = weaponInventory.get(0);
            w.setWeaponAttack(w.getWeaponAttack() + wa);
            weaponInventory.set(0,w);
            
            message = "Attack increase successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon equipped. Please purchase a weapon.";
           // el.doErrorLog(ioobe.getStackTrace());
        }
        JOptionPane.showMessageDialog(null,message);
    }
    public int getItemInventoryCounter()
    {
        return itemInventoryCounter;
    }
    public ArrayList<Item> getItemInventory()
    {
        return itemInventory;
    }
    
    public ArrayList<Item> getStoreItem()
    {
        return storeItems;
    }
    //</editor-fold>
  
    //<editor-fold defaultstate="collapsed" desc="Location Methods">
    public void setMapData(int[][] md)
    {
        mapData = md;
    }
    
    public int[][] getMapData()
    {
        return mapData;
    }
    public ArrayList<LocationConverter> getLocationList()
    {
        return locationList;
    }
    private void setPlaceWithName(String placename)
    {
        for(LocationConverter lc : locationList)
        {
            if(lc.getName().equals(placename))
            {
                lc.setVisited(true);
                setHeroLocation(lc.getTopLeft());
                heroCityName = placename;
            }
        }
    }
    
    public void setPlaceWithPoint(Point p)
    {
        for(LocationConverter lc : locationList)
        {
            Point topplacepoint = lc.getTopLeft();
            Point botplacepoint = lc.getBottomRight();
            int topplacex = (int)topplacepoint.getX();
            int topplacey = (int)topplacepoint.getY();
            int botplacex = (int)botplacepoint.getX();
            int botplacey = (int)botplacepoint.getY();
            int plaplacex = (int)p.getX();
            int plaplacey = (int)p.getY();
            
            if(((plaplacex > topplacex) && (plaplacex < botplacex)) && ((plaplacey > topplacey) && (plaplacey < botplacey)))
            {
                lc.setVisited(true);
                setHeroLocation(lc.getTopLeft());
                heroCityName = lc.getName();
                System.out.println("CITY");
            }
            else
            {

              //  heroCityName = "";
                
            }
        }
    }
    
    public void setPlaceWithColor(int green)
    {
        for(LocationConverter lc: locationList)
        {
            int gv = lc.getGreenVal();
            if(gv == green)
            {
                lc.setVisited(true);
                heroCityName = lc.getName();
                break;
            }
            else
            {
                heroCityName = "Exploring...";
            }
        }
    }
    
    public void setHeroLocation(Point p)
    {
        heroLocation = p;
    }
    
    public Point getHeroLocation()
    {
        return heroLocation;
    }
    
    public String getHeroCityName()
    {
        return heroCityName;
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Store Methods">
    public void stockWeaponStore(int n)
    {
        {
            storeWeapons.clear();
            for (int i = 0; i < n; i++)
            {
                Weapon w = new Weapon("Random");
                w.setWeaponValue(w.getWeaponValue() + 5 + (w.getWeaponValue() * .85 ) * (2 * heroLevel * .99));
                w.setWeaponAttack(w.getWeaponAttack() + (heroLevel * 4));
                storeWeapons.add(w);              
            }
            
        }
    }
    
    public void stockItemStore(int n)
    {
        if (storestock <= 3)
        {        
            storeItems.clear();
            for (int z = 0; z < n; z++)
            {
                Item i = new Item("Random");
                i.setItemValue(i.getItemValue() + 5 + /*(i.getValue() * .85 )*/ (2 * heroLevel * .99));
                storeItems.add(i);
                
            }
            
        }
        else
        {
            Item i = new Item("Ranodm");   
            storeItems.add(i);  
        }
    }
    
    public String buyWeapon(int a)
    {
        String finalmessage;
        try
        {
            Weapon w = storeWeapons.get(a);
            if((heroMoney - w.getWeaponValue()) > 0)
            {
                if(!addWeapon(w).equals("Inventory Full"))
                {
                    heroMoney = heroMoney - w.getWeaponValue();
                    w.setWeaponValue(w.getWeaponValue() - 10 - (heroLevel * .75));
                    storeWeapons.remove(a);
                    finalmessage = "Weapon purchased";
             
                }
                else
                {
                    finalmessage = "Inventory Full";
                }
            }
            else
            {
                finalmessage = "Cannot afford the weapon.";
            }
        }
        catch(NullPointerException npe)
        {
            finalmessage = ("Please select a different weapon.");
           // el.doErrorLog(npe.getStackTrace());
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = ("Please select an item.");
            //el.doErrorLog(ioobe.getStackTrace());
        }
        
        return finalmessage;
    }
    
    public String buyItem(int a)
    {
        String finalmessage;
        try
        {
            Item i = storeItems.get(a);
            if((heroMoney - i.getItemValue()) > 0)
            {
                if(!addItem(i).equals("Inventory Full"))
                {        
                    heroMoney = heroMoney - i.getItemValue();
                    double nValue = i.getItemValue() - 10;
                    if (nValue <= 0)
                    {
                        nValue = 5;
                    }
                    i.setItemValue(nValue);
                    storeItems.remove(a);
                    finalmessage = "Item purchased";
                   
                }
                else
                {
                    finalmessage = "Inventory Full";
                }
            }
            else
            {
                finalmessage = "Cannot afford the item.";
            }
        }
        catch(NullPointerException npe)
        {
            finalmessage = ("Please select a different weapon.");
           // el.doErrorLog(npe.getStackTrace());
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = ("Please select an item.");
            //el.doErrorLog(ioobe.getStackTrace());
        }
        
        return finalmessage;       
    }
    
    public void setStoreStock(int s)
    {
        storestock = s;
    }
    
    public int getStoreStock()
    {
        return storestock;
    }
    //</editor-fold>

    
}