package Menus;

import Enemies.Enemy;
import javax.swing.JOptionPane;
import Hero.*;
import Items.Item;
import Tools.*;
import Weapons.Weapon;

public class Battle extends javax.swing.JFrame 
{
    private boolean getExp;  
    private final Hero h;
    private final Enemy e;
    private int enemyStartHealth;
    
    public Battle(Hero hl) 
    { 
        initComponents();             
        Enemy e1 = new Enemy("Random");
        e = e1;   
        h = hl;
        enemyStartHealth = e1.getEnemyHealth();
        e1.setEnemyAttack(e1.getEnemyAttack() +( hl.getHeroLevel()^3 /32) * 2);
        heroHealthBar.setMaximum(h.heroDefaultHealth);
        enemyHealthBar.setMaximum(e.getEnemyHealth());
        heroHealthBar.setValue(h.getHeroHealth());
        enemyHealthBar.setValue(e.getEnemyHealth());
        heroHealthBar.setStringPainted(true);
        enemyHealthBar.setStringPainted(true);
        heroHealthBar.setString(h.getHeroHealth() + "/" + h.heroDefaultHealth);
        enemyHealthBar.setString(e.getEnemyHealth() + "/" + enemyStartHealth);
        updateDisplay();
    }
    
    public final void updateDisplay()
    {
        heroStatsArea.setText(h.displayHeroStats());
        weaponArea.setText(h.displayCurrentWeapon());
        enemyArea.setText(e.displayEnemy());
        heroHealthBar.setValue(h.getHeroHealth());
        enemyHealthBar.setValue(e.getEnemyHealth());
        heroHealthBar.setStringPainted(true);
        enemyHealthBar.setStringPainted(true);
        heroHealthBar.setString(h.getHeroHealth() + "/" + h.heroDefaultHealth);
        enemyHealthBar.setString(e.getEnemyHealth() + "/" + enemyStartHealth);
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        heroStats = new javax.swing.JPanel();
        heroStatsScroll = new javax.swing.JScrollPane();
        heroStatsArea = new javax.swing.JTextArea();
        heroHealthBar = new javax.swing.JProgressBar();
        battleLogPanel = new javax.swing.JPanel();
        battleLogScroll = new javax.swing.JScrollPane();
        battleLogArea = new javax.swing.JTextArea();
        enemyPanel = new javax.swing.JPanel();
        enemyScroll = new javax.swing.JScrollPane();
        enemyArea = new javax.swing.JTextArea();
        enemyHealthBar = new javax.swing.JProgressBar();
        weaponPanel = new javax.swing.JPanel();
        weaponScroll = new javax.swing.JScrollPane();
        weaponArea = new javax.swing.JTextArea();
        actionPanel = new javax.swing.JPanel();
        attackFists = new javax.swing.JButton();
        attackWeapon = new javax.swing.JButton();
        checkInventory = new javax.swing.JButton();
        tryToEscape = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Battle - Legend of the Secret");
        addWindowFocusListener(new java.awt.event.WindowFocusListener()
        {
            public void windowGainedFocus(java.awt.event.WindowEvent evt)
            {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt)
            {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                formWindowClosing(evt);
            }
        });

        heroStats.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));

        heroStatsArea.setEditable(false);
        heroStatsArea.setColumns(20);
        heroStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStatsArea.setRows(5);
        heroStatsScroll.setViewportView(heroStatsArea);

        javax.swing.GroupLayout heroStatsLayout = new javax.swing.GroupLayout(heroStats);
        heroStats.setLayout(heroStatsLayout);
        heroStatsLayout.setHorizontalGroup(
            heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroStatsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroHealthBar, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        heroStatsLayout.setVerticalGroup(
            heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroStatsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroHealthBar, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(heroStatsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsLayout.createSequentialGroup()
                    .addGap(47, 47, 47)
                    .addComponent(heroStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        battleLogPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Battle Log"));

        battleLogArea.setEditable(false);
        battleLogArea.setColumns(20);
        battleLogArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        battleLogArea.setLineWrap(true);
        battleLogArea.setRows(5);
        battleLogScroll.setViewportView(battleLogArea);

        javax.swing.GroupLayout battleLogPanelLayout = new javax.swing.GroupLayout(battleLogPanel);
        battleLogPanel.setLayout(battleLogPanelLayout);
        battleLogPanelLayout.setHorizontalGroup(
            battleLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(battleLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(battleLogScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        battleLogPanelLayout.setVerticalGroup(
            battleLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(battleLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(battleLogScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)
                .addContainerGap())
        );

        enemyPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Enemy Stats"));

        enemyArea.setEditable(false);
        enemyArea.setColumns(20);
        enemyArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        enemyArea.setRows(5);
        enemyScroll.setViewportView(enemyArea);

        javax.swing.GroupLayout enemyPanelLayout = new javax.swing.GroupLayout(enemyPanel);
        enemyPanel.setLayout(enemyPanelLayout);
        enemyPanelLayout.setHorizontalGroup(
            enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(enemyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(enemyScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(enemyPanelLayout.createSequentialGroup()
                    .addGap(11, 11, 11)
                    .addComponent(enemyHealthBar, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                    .addGap(12, 12, 12)))
        );
        enemyPanelLayout.setVerticalGroup(
            enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, enemyPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(enemyScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(enemyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(enemyPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(enemyHealthBar, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(126, Short.MAX_VALUE)))
        );

        weaponPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Stats"));

        weaponArea.setEditable(false);
        weaponArea.setColumns(20);
        weaponArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        weaponArea.setRows(5);
        weaponScroll.setViewportView(weaponArea);

        javax.swing.GroupLayout weaponPanelLayout = new javax.swing.GroupLayout(weaponPanel);
        weaponPanel.setLayout(weaponPanelLayout);
        weaponPanelLayout.setHorizontalGroup(
            weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 223, Short.MAX_VALUE)
            .addGroup(weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 203, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponPanelLayout.setVerticalGroup(
            weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(weaponPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        actionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        attackFists.setText("Attack with Fists");
        attackFists.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                attackFistsActionPerformed(evt);
            }
        });

        attackWeapon.setText("Attack with Weapon");
        attackWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                attackWeaponActionPerformed(evt);
            }
        });

        checkInventory.setText("Check Inventory");
        checkInventory.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                checkInventoryActionPerformed(evt);
            }
        });

        tryToEscape.setText("Try to escape");
        tryToEscape.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                tryToEscapeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout actionPanelLayout = new javax.swing.GroupLayout(actionPanel);
        actionPanel.setLayout(actionPanelLayout);
        actionPanelLayout.setHorizontalGroup(
            actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(attackWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(attackFists, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(tryToEscape, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(checkInventory, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        actionPanelLayout.setVerticalGroup(
            actionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionPanelLayout.createSequentialGroup()
                .addContainerGap(18, Short.MAX_VALUE)
                .addComponent(attackFists)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(attackWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(tryToEscape)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(checkInventory)
                .addGap(17, 17, 17))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(battleLogPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(weaponPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(actionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(heroStats, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(enemyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(heroStats, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(battleLogPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(weaponPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(enemyPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(actionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void heroAttacks(int ha)
    {
        RDN rn = new RDN(40);
        int r = rn.RN();
        int stat = ha + r;
        int dmcon = h.getWeaponInventory().get(0).getWeaponAttack();
        double damage = ((stat^3 / 32) + 32) * dmcon / 16;
        RDN randomHero = new RDN(15);
        RDN randomEnemy = new RDN(15);
        int randomPoison = randomHero.RN() + (2 * h.getHeroLevel());
        e.setEnemyAttack(e.getEnemyAttack() + randomEnemy.RN() + (h.getHeroLevel() * 2));
        int paralyzeChanceRDN = randomHero.sRN();        
        
        switch(h.getHeroStatus())
        {
            case "Normal":
            {
                battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                battleLogArea.append("\n");
                break;
           }
           case "Poison":
           {
                battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                battleLogArea.append("\n");           
                battleLogArea.append("\n" + "You are poisoned. You lose an additonal " + randomPoison + " points of health.");
                h.setHeroHealth(h.getHeroHealth() - randomPoison);
                battleLogArea.append("\n");
                break;
           }
           case "Burn":
           {
                battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                battleLogArea.append("\n");        
                battleLogArea.append("\n" + "You are burned. You lose an additonal " + randomPoison + " points of health.");
                h.setHeroHealth(h.getHeroHealth() - randomPoison);
                battleLogArea.append("\n");
                break;
           }
           case "Paralyze":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are paralyzed. You cannot attack.");
                }
                else
                {
                    battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                    e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                    battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                    battleLogArea.append("\n");
                }
                break;
           }
           case "Sleep":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are asleep. You cannot attack.");
                }
                else
                {
                    battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                    e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                    battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                    battleLogArea.append("\n");
                }
                break;
           }
           case "Confusion":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    battleLogArea.append("\n" + "You are confused. You have hurt yourself in confusion. You loose an additional " + randomPoison + " points of health.");
                    h.setHeroHealth(h.getHeroHealth() - randomPoison);
                }
                else
                {
                    battleLogArea.append("\n" + h.getHeroName() + " attacks the " + e.getEnemyName() + " and does " + (int)damage + " damage.");
                    e.setEnemyHealth(e.getEnemyHealth() - (int)damage);
                    battleLogArea.append("\n" + "The " + e.getEnemyName() + " now has " + e.getEnemyHealth() + " health left.");
                    battleLogArea.append("\n");
                }
                break;
           }
       }
    }
    
    private void enemyAttacks()
    {
         RDN rn = new RDN(20);
        int r = rn.RN();
        
        updateDisplay();
        int stat = e.getEnemyAttack() + r;
        int dmcon = rn.RN();
        double damage = ((stat^3 / 32) + 32) * dmcon / 16;
        
        battleLogArea.append("\n" + "The " + e.getEnemyName() + " attacks " + h.getHeroName() + " and does " + (int)damage + " damage.");
        h.setHeroHealth(h.getHeroHealth() - (int)damage);
        battleLogArea.append("\n" + h.getHeroName() + " now has " + h.getHeroHealth() + " health left.");
        battleLogArea.append("\n");
        if (h.getHeroStatus().equals("Normal"))
        {
            RDN r4 = new RDN(6);//random status
            RDN r3 = new RDN(50);//chance to do random status
            int tempstatus;
            int temprdstatus;
            tempstatus = r4.RN();
            temprdstatus = r3.RN();
            String[] statuslist = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion", "Normal"};
            String status = statuslist[tempstatus];
            if (temprdstatus > 35)
            {
                h.setHeroStatus(status);
                String sMessage;
                if(!status.equals("Normal"))
                {
                sMessage = "You have been hurt by the enemy.\n Your status is: " + "\n" + h.getHeroStatus();
                JOptionPane.showMessageDialog(null, sMessage);
                }
            }    
        }
        
    }
    
    private void attackFistsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackFistsActionPerformed
 
       updateDisplay();
       heroAttacks(h.getHeroAttack());
       enemyAttacks();
       getExp = true;

       if((e.getEnemyHealth() <= 0 && h.getHeroHealth() >= 0) || (h.getHeroHealth() <= 0))
       {
            boolean result = false;
            if(h.getHeroHealth() <= 0)
            {
                result = true;
            }
            battleEnd(result);
       }
       updateDisplay();
    }//GEN-LAST:event_attackFistsActionPerformed

    private void attackWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackWeaponActionPerformed
        
        if(!h.getWeaponInventory().isEmpty())
        {
            Weapon w = h.getWeaponInventory().get(0);
            RDN r2 = new RDN(6);
            int decWepHlth = r2.sRN();
            heroAttacks(h.getHeroAttack() + w.getWeaponAttack());
            enemyAttacks();
            w.setWeaponHealth(w.getWeaponHealth() - decWepHlth); 
            h.getWeaponInventory().set(0,w);
            getExp = true;
            if((e.getEnemyHealth() <= 0 && h.getHeroHealth() >= 0) || (h.getHeroHealth() <= 0))
            {
                boolean result = false;
                if(h.getHeroHealth() <= 0)
                {
                    result = true;
                }
                battleEnd(result);
            }
            updateDisplay();
        }
        else
        {
            JOptionPane.showMessageDialog(null, "You do not have a weapon. Either attack with your fists or try to escape.");
        }
    }//GEN-LAST:event_attackWeaponActionPerformed

    private void tryToEscapeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tryToEscapeActionPerformed
       getExp = false;
       RDN es = new RDN(11);
       int escape = es.RN();
       int newhealth;
       newhealth = e.getEnemyHealth() + escape;
       if (escape % 2 == 0)
       {
            e.setEnemyHealth(-5);
            JOptionPane.showMessageDialog(null,"You have successfully escaped...");
            enemyStartHealth = 0;
            Battle.this.dispose();
            Explore eg = new Explore(h);
            eg.setLocationRelativeTo(null);
            eg.setVisible(true);
       }
       else
       {
           JOptionPane.showMessageDialog(null,"Escape attempt failed...");
           e.setEnemyHealth(newhealth);
       }
       
    }//GEN-LAST:event_tryToEscapeActionPerformed

    private void checkInventoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkInventoryActionPerformed
       Inventory ig = new Inventory(h);
              ig.setLocationRelativeTo(null);
              ig.setVisible(true);
    }//GEN-LAST:event_checkInventoryActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       updateDisplay();
    }//GEN-LAST:event_formWindowGainedFocus

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
       int result = JOptionPane.showConfirmDialog(null,"Are you sure you want to quit. If you click, \nYES, the game will end... WITHOUT SAVING. \n You must finish the battle to be able to save and quit.","Quit?", JOptionPane.YES_NO_OPTION);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
    }//GEN-LAST:event_formWindowClosing
    
    public void battleEnd(boolean lose)
    {        
        DisplayFormat df = new DisplayFormat();
        if (e.getEnemyHealth() <= 0)
        {
             if (getExp == true && lose == false)
             {
                 int expold = h.getHeroExp();
                 RDN rExp = new RDN(3);
                 int rdExp = rExp.RN();
                 int expchange = enemyStartHealth * (rdExp + 1);
                 int expnew = expold + expchange;
                 h.setHeroExp(expchange);
                 String eMessage1 = "The enemy is dead." + "\n\nYou have gained " + expchange + " points of experience." + "\n" + "Your current exp is now at: " + expnew;
                 //JOptionPane.showMessageDialog(null, eMessage1);
                 Item item = new Item("Random");
                 eMessage1 = eMessage1 + "\n\nThe enemy dropped an item.";
//                 JOptionPane.showMessageDialog(null, iMessage1);                
                 eMessage1 = eMessage1 + "\n" + h.addItem(item);
//                 JOptionPane.showMessageDialog(null, iMessage1); 
//                 RDN rCash = new RDN(10);
//                 int rdCash = rCash.RN(); 
                 
                 double mMess = Math.abs((h.getHeroLevel() * .7) + (enemyStartHealth * .5));
                 eMessage1 = eMessage1 + "\n\nYou have also recieved " + df.formatCurrency(mMess);
                 JOptionPane.showMessageDialog(null,eMessage1);
                 h.setHeroMoney((h.getHeroMoney()) + (h.getHeroLevel() * .7) + (enemyStartHealth * .5));   
                 //h.setTravels(h.getTravels() + " and won!!"+"\n-----------------------------------------\n");
                 Battle.this.dispose();
                 Explore eg = new Explore(h);
                 eg.setLocationRelativeTo(null);
                 eg.setVisible(true);
             }
        }
        if(h.getHeroHealth() <= 0 && lose == true)
        { 
               JOptionPane.showMessageDialog(null, "You are dead");               
               h.setHeroExp(-50);
               double losemoney = h.getHeroMoney();
               double moneydec = losemoney * .25;
               losemoney = losemoney - moneydec;
               if (losemoney <= 0)
               {
                   losemoney = 0;
               }
               h.setHeroMoney(losemoney);
               h.setHeroHealth(h.getHeroDefaultHealth());
               String dMessage = "You have lost " + df.formatCurrency(moneydec) + "\n" + "You have also lost 50 exp." + "\n" + "Your health has been reset to " + h.getHeroHealth() + ".";
               JOptionPane.showMessageDialog(null, dMessage);
               Battle.this.dispose();
               Explore eg = new Explore(h);
               eg.setLocationRelativeTo(null);
               eg.setVisible(true);
        }                              
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel actionPanel;
    private javax.swing.JButton attackFists;
    private javax.swing.JButton attackWeapon;
    private javax.swing.JTextArea battleLogArea;
    private javax.swing.JPanel battleLogPanel;
    private javax.swing.JScrollPane battleLogScroll;
    private javax.swing.JButton checkInventory;
    private javax.swing.JTextArea enemyArea;
    private javax.swing.JProgressBar enemyHealthBar;
    private javax.swing.JPanel enemyPanel;
    private javax.swing.JScrollPane enemyScroll;
    private javax.swing.JProgressBar heroHealthBar;
    private javax.swing.JPanel heroStats;
    private javax.swing.JTextArea heroStatsArea;
    private javax.swing.JScrollPane heroStatsScroll;
    private javax.swing.JButton tryToEscape;
    private javax.swing.JTextArea weaponArea;
    private javax.swing.JPanel weaponPanel;
    private javax.swing.JScrollPane weaponScroll;
    // End of variables declaration//GEN-END:variables
}
