package Menus;


import Hero.*;
import Places.LocationConverter;
import Tools.*;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.io.*;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

public final class Explore extends javax.swing.JFrame 
{
    private final Hero hero;  
    private int tempexp = 0;
    ImageIcon up = new ImageIcon(getClass().getResource("/Menus/hUp.png"));
    ImageIcon down = new ImageIcon(getClass().getResource("/Menus/hDown.png"));
    ImageIcon left = new ImageIcon(getClass().getResource("/Menus/hLeft.png"));
    ImageIcon right = new ImageIcon(getClass().getResource("/Menus/hRight.png"));   
    ArrayList<LocationConverter> locationList;
    ErrorLog el = new ErrorLog();
    
    public Explore(Hero h)
    {    
        initComponents();
        heroStatsArea.append(h.displayHeroStats());
        weaponStatsArea.append(h.displayCurrentWeapon());
        hero = h;
        locationList = h.getLocationList();
        
        player.setLocation(h.getHeroLocation());
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        heroStatsPanel = new javax.swing.JPanel();
        heroStatsScroll = new javax.swing.JScrollPane();
        heroStatsArea = new javax.swing.JTextArea();
        saveQuitPanel = new javax.swing.JPanel();
        save = new javax.swing.JButton();
        saveQuit = new javax.swing.JButton();
        weaponStatsPanel = new javax.swing.JPanel();
        weaponStatsScroll = new javax.swing.JScrollPane();
        weaponStatsArea = new javax.swing.JTextArea();
        focusGetter = new javax.swing.JButton();
        showInventory = new javax.swing.JButton();
        mapLayeredPane = new javax.swing.JLayeredPane();
        coordText = new javax.swing.JLabel();
        cityLabel = new javax.swing.JLabel();
        player = new javax.swing.JLabel();
        map = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Explore - Legend of the Secret");
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
        });

        heroStatsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));
        heroStatsPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                heroStatsPanelMouseClicked(evt);
            }
        });
        heroStatsPanel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                heroStatsPanelKeyPressed(evt);
            }
        });

        heroStatsArea.setEditable(false);
        heroStatsArea.setColumns(20);
        heroStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStatsArea.setLineWrap(true);
        heroStatsArea.setRows(5);
        heroStatsScroll.setViewportView(heroStatsArea);

        javax.swing.GroupLayout heroStatsPanelLayout = new javax.swing.GroupLayout(heroStatsPanel);
        heroStatsPanel.setLayout(heroStatsPanelLayout);
        heroStatsPanelLayout.setHorizontalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 203, Short.MAX_VALUE)
                .addContainerGap())
        );
        heroStatsPanelLayout.setVerticalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, heroStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                .addContainerGap())
        );

        saveQuitPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Save/Quit"));

        save.setText("Save Progress");
        save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveActionPerformed(evt);
            }
        });

        saveQuit.setText("Save and Quit");
        saveQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveQuitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout saveQuitPanelLayout = new javax.swing.GroupLayout(saveQuitPanel);
        saveQuitPanel.setLayout(saveQuitPanelLayout);
        saveQuitPanelLayout.setHorizontalGroup(
            saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(saveQuitPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(save)
                    .addComponent(saveQuit)))
        );
        saveQuitPanelLayout.setVerticalGroup(
            saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(saveQuitPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(save)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(saveQuit))
        );

        weaponStatsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Stats"));

        weaponStatsArea.setEditable(false);
        weaponStatsArea.setColumns(20);
        weaponStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        weaponStatsArea.setLineWrap(true);
        weaponStatsArea.setRows(5);
        weaponStatsScroll.setViewportView(weaponStatsArea);

        javax.swing.GroupLayout weaponStatsPanelLayout = new javax.swing.GroupLayout(weaponStatsPanel);
        weaponStatsPanel.setLayout(weaponStatsPanelLayout);
        weaponStatsPanelLayout.setHorizontalGroup(
            weaponStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(weaponStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 198, Short.MAX_VALUE)
                .addContainerGap())
        );
        weaponStatsPanelLayout.setVerticalGroup(
            weaponStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(weaponStatsScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 115, Short.MAX_VALUE)
                .addContainerGap())
        );

        focusGetter.setBorder(null);
        focusGetter.setBorderPainted(false);
        focusGetter.setOpaque(false);
        focusGetter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                focusGetterActionPerformed(evt);
            }
        });
        focusGetter.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                focusGetterKeyPressed(evt);
            }
        });

        showInventory.setText("Inventory");
        showInventory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showInventoryActionPerformed(evt);
            }
        });
        showInventory.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                showInventoryKeyPressed(evt);
            }
        });

        coordText.setForeground(new java.awt.Color(255, 255, 255));
        coordText.setText("<html></html>");
        coordText.setToolTipText("");
        mapLayeredPane.add(coordText);
        coordText.setBounds(610, 510, 140, 30);

        cityLabel.setForeground(new java.awt.Color(255, 255, 255));
        mapLayeredPane.add(cityLabel);
        cityLabel.setBounds(570, 540, 140, 30);

        player.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Menus/hRight.png"))); // NOI18N
        player.setAlignmentY(0.0F);
        mapLayeredPane.add(player);
        player.setBounds(270, 410, 20, 17);

        map.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Menus/map.png"))); // NOI18N
        map.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                mapMouseClicked(evt);
            }
        });
        map.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                mapMouseMoved(evt);
            }
        });
        mapLayeredPane.add(map);
        map.setBounds(0, 0, 770, 580);

        jButton2.setText("Battle");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton1.setText("Store");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setText("<html>Use the arrow keys to move around. Click on a city to travel there.</html>");

        jButton3.setText("Map Legend");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(mapLayeredPane, javax.swing.GroupLayout.PREFERRED_SIZE, 770, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(7, 7, 7)
                        .addComponent(focusGetter))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(weaponStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(heroStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(layout.createSequentialGroup()
                            .addGap(137, 137, 137)
                            .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(saveQuitPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(showInventory)
                                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(mapLayeredPane, javax.swing.GroupLayout.PREFERRED_SIZE, 580, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(focusGetter)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(1, 1, 1)
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButton1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(showInventory)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton2))
                            .addComponent(saveQuitPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(weaponStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(heroStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       weaponStatsArea.setText(hero.displayCurrentWeapon());
       heroStatsArea.setText(hero.displayHeroStats());
       
    }//GEN-LAST:event_formWindowGainedFocus

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    
       Object[] options = {"Quit Without Saving","Save and Quit", "Return to the Game"};
       int result = JOptionPane.showOptionDialog(null, "Are you sure you want to quit without saving?","Quit?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[2]);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
       if(result == JOptionPane.NO_OPTION)
       {
           String gs = hero.getHeroName() + ".ser";
            ObjectOutputStream oos1;
            try
            {
                oos1 = new ObjectOutputStream (new FileOutputStream(gs));
                oos1.writeObject(hero);
                oos1.flush();
                oos1.close();
                String message = "The hero with the name " + hero.getHeroName() + " has been saved with the filename " + gs + ".";
                JOptionPane.showMessageDialog(null,message);
                System.exit(0);          
            }
            catch(IOException ioe)
            {
                JOptionPane.showMessageDialog(null, ioe.toString());
                el.doErrorLog(ioe.getStackTrace());
            }
        }
    }//GEN-LAST:event_formWindowClosing
   
    private void moveCharacter(KeyEvent evt)
    {
        Point loc = new Point(player.getLocation());
        int x = (int)loc.getX();
        int y = (int)loc.getY();
        int w = 755;
        int h = 565;
        {
            if(evt.getKeyCode() == KeyEvent.VK_UP)
            {
                player.setIcon(up);
                player.setLocation(x, (y-1));
                if(y<=0)
                {
                        player.setLocation(x, (y+2));
                        
                }
            }
            if(evt.getKeyCode() == KeyEvent.VK_DOWN)
            {
                player.setLocation(x, (y+1));
                player.setIcon(down);
                if(y>=h)
                {
                    player.setLocation(x, (y-2));
                }    
            }
            if(evt.getKeyCode() == KeyEvent.VK_LEFT)
            {
                player.setLocation((x-1), y);
                player.setIcon(left);
                if(x<=0)
                {
                    player.setLocation((x+2), y);
                }
            }
            if(evt.getKeyCode() == KeyEvent.VK_RIGHT)
            {
                player.setLocation((x+1), y);
                player.setIcon(right);
                if(x>=w)
                {
                    player.setLocation((x-2), y);
                }
            }
        }
        hero.setHeroLocation(player.getLocation());
       // hero.setPlaceWithPoint(player.getLocation());
        int[][] ca = hero.getMapData();
        hero.setPlaceWithColor(ca[y][x]);
        int battlecolor = ca[y][x];
        switch (battlecolor)
        {
            case 230:
            {
                System.out.println("No Grass");
                break;
            }
            case 231:
            {
                System.out.println("Light Grass");
                Random r = new Random();
                Float chance1 = r.nextFloat();
                if (chance1 <= .05)
                {
                    System.out.println(chance1);
                    Explore.this.dispose();
                    Battle eg = new Battle(hero);
                    eg.setLocationRelativeTo(null);
                    eg.setVisible(true);
                        
                }
                else
                {
                    System.out.println(chance1);
                }
                break;
            }
            case 210:
            {
                System.out.println("Med Grass");
                break;
            }
            case 190:
            {
                System.out.println("Heavy Grass");
                break;
            }
            default:
            {
                System.out.println("NOT WORKING");
                break;
            }
        }
        coordText.setText("X: " + x + " Y: " + y);
        cityLabel.setText("Location: " + hero.getHeroCityName());
    }
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened

    }//GEN-LAST:event_formWindowOpened

    private void saveQuitActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveQuitActionPerformed
    {//GEN-HEADEREND:event_saveQuitActionPerformed

        FileManagement fm = new FileManagement();
        fm.saveFile(hero);
        System.exit(0);
    }//GEN-LAST:event_saveQuitActionPerformed

    private void saveActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveActionPerformed
    {//GEN-HEADEREND:event_saveActionPerformed

        FileManagement fm = new FileManagement();
        fm.saveFile(hero);

    }//GEN-LAST:event_saveActionPerformed

    private void focusGetterActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_focusGetterActionPerformed
    {//GEN-HEADEREND:event_focusGetterActionPerformed
       tempexp = tempexp + 100;
       hero.setHeroExp(tempexp);
       heroStatsArea.setText(hero.displayHeroStats());
    }//GEN-LAST:event_focusGetterActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton2ActionPerformed
    {//GEN-HEADEREND:event_jButton2ActionPerformed
        Explore.this.dispose();
        Battle eg = new Battle(hero);
        eg.setLocationRelativeTo(null);
        eg.setVisible(true);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void showInventoryActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showInventoryActionPerformed
    {//GEN-HEADEREND:event_showInventoryActionPerformed

        Inventory eg = new Inventory(hero);
        eg.setLocationRelativeTo(null);
        eg.setVisible(true);
    }//GEN-LAST:event_showInventoryActionPerformed

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed
        moveCharacter(evt);
    }//GEN-LAST:event_formKeyPressed

    private void focusGetterKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_focusGetterKeyPressed
        moveCharacter(evt);
    }//GEN-LAST:event_focusGetterKeyPressed

    private void heroStatsPanelKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_heroStatsPanelKeyPressed
        moveCharacter(evt); 
    }//GEN-LAST:event_heroStatsPanelKeyPressed

    private void showInventoryKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_showInventoryKeyPressed
        moveCharacter(evt);
    }//GEN-LAST:event_showInventoryKeyPressed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Store eg = new Store(hero,"Bluespring Village");
        eg.setLocationRelativeTo(null);
        eg.setVisible(true);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void mapMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_mapMouseClicked
    {//GEN-HEADEREND:event_mapMouseClicked
      int x = evt.getX();
      int y = evt.getY();
      Point z1;
      Point z2;
      for(LocationConverter lc : locationList)
        {
            z1 = lc.getTopLeft();
            z2 = lc.getBottomRight();
            if((x >= z1.getX() && x <= z2.getX()) && (y >= z1.getY() && y < z2.getY()))
            {
                if(lc.getVisited())
                {
                    travel(lc.getName());
                }
                else
                {
                    JOptionPane.showMessageDialog(null,"You have not been here yet, please visit this town before you can quick travel to here.");
                }
            }
        }
        
    }//GEN-LAST:event_mapMouseClicked

    private void mapMouseMoved(java.awt.event.MouseEvent evt)//GEN-FIRST:event_mapMouseMoved
    {//GEN-HEADEREND:event_mapMouseMoved
      
      //do
      {    
        int x = evt.getX();
        int y = evt.getY();
        Point z1;
        Point z2;
        for(LocationConverter lc : locationList)
          {
              z1 = lc.getTopLeft();
              z2 = lc.getBottomRight();
              if((x >= z1.getX() && x <= z2.getX()) && (y >= z1.getY() && y < z2.getY()))
              {
                  map.setToolTipText(lc.getName());
              }
             
          }
        
      }//while;
    }//GEN-LAST:event_mapMouseMoved

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton3ActionPerformed
    {//GEN-HEADEREND:event_jButton3ActionPerformed
        Map eg = new Map(hero);
        eg.setLocationRelativeTo(null);
        eg.setVisible(true);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void heroStatsPanelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_heroStatsPanelMouseClicked
        //new MapUtil().doArray();

    }//GEN-LAST:event_heroStatsPanelMouseClicked
   
    private void travel(String placename)
    {
        JOptionPane.showMessageDialog(null,"Travel to " + placename + "?");
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel cityLabel;
    private javax.swing.JLabel coordText;
    private javax.swing.JButton focusGetter;
    private javax.swing.JTextArea heroStatsArea;
    private javax.swing.JPanel heroStatsPanel;
    private javax.swing.JScrollPane heroStatsScroll;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel map;
    private javax.swing.JLayeredPane mapLayeredPane;
    private javax.swing.JLabel player;
    private javax.swing.JButton save;
    private javax.swing.JButton saveQuit;
    private javax.swing.JPanel saveQuitPanel;
    private javax.swing.JButton showInventory;
    private javax.swing.JTextArea weaponStatsArea;
    private javax.swing.JPanel weaponStatsPanel;
    private javax.swing.JScrollPane weaponStatsScroll;
    // End of variables declaration//GEN-END:variables
}
