import java.io.*;
import java.util.*;

public class MainGame
{
	static String name = "";
	static Scanner userInput = new Scanner (System.in);
	static Hero hero = new Hero(); //create new hero
	static Enemy enemy = new Enemy(); //create new enemy
	static Hero heroLoad;
	
	public static void main(String args[])
	{	
		
		printLogo pl = new printLogo(); //load the welcome logo
		createVersion();
		mainMenu();
	}
	
	public static void mainMenu()
	{
		Bar b = new Bar();
		
		//b.Bar(50);
		//b.Bar(100);
		//System.out.println("\n\n\n\n");
		String menuoption;
		int error = 0;
		do
		{
			System.out.println("Enter '1' to start a new game, '2' to load previous game, and '3' to Exit:");
			menuoption = userInput.next();
			if(isInt(menuoption) == true)
			{
				switch(Integer.parseInt(menuoption))
				{
					case 1:
					{
						newGame(); 
						error = 1;
						break;
					} //create new game
					case 2:
					{
						//System.out.println("LOADING..........");
						//b.Bar(100);
						//System.out.println();
						loadGame();
						error = 1;
						break;
					} //load previous game save
					case 3:
					{
						System.out.println("Goodbye.");
						error = 1;
						break;
					}
					default:
					{
						break;
					}
				}
			}
		}
		while (error !=1);
	}
	
	public static void newGame()
	{	
		String savename = "";
		System.out.print("Enter name: ");
		name = userInput.next();
		hero.setName(name);
		savename = name + ".ser";
		saveGame(savename, hero);
		Explore exp = new Explore(hero);
	}
	
	public static void loadGame()
	{
		ObjectInputStream input;
		String loadName;
		System.out.println("Enter hero name, to go back to the main menu type (mm): ");
		name = userInput.next();
		loadName = name + ".ser";
		if (name.equals("mm"))
		{
			mainMenu();
		}
		else
		{
			try
			{
				input = new ObjectInputStream(new FileInputStream(loadName));
				heroLoad = (Hero)input.readObject();
				Explore exp = new Explore(heroLoad);
			}
			
			catch(EOFException eofe)
			{
				System.out.println("Filename not found, please try again.");
				
				loadGame();
			}
			
			catch(ClassNotFoundException cnfe)
			{
				System.out.println("Filename not found, please try again.");
				loadGame();
			}
			
			catch(IOException ioe)
			{
				System.out.println("Filename not found, please try again.");
				loadGame();
			}
		}
	}
	
	public static void saveGame(String n, Hero hc) //possibly put save and load in its own class.
	{
		try
		{
			ObjectOutputStream output;
			output = new ObjectOutputStream (new FileOutputStream(n));
			output.writeObject(hc);
			output.flush();
			output.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}

	public static void createVersion()
	{
		double version = 0.0000;
		Scanner inputV;
		Formatter outputV;
		try
		{
			inputV = new Scanner(new File("version.txt"));
			while(inputV.hasNext())
			{
				version = inputV.nextDouble();
			}
			inputV.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		
		version = version + .0001;
		
		try
		{
			outputV = new Formatter("version.txt");
			outputV.format("%f", version);
			outputV.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		System.out.println("Version: " + version);
	}
}