import java.text.DecimalFormat;
import javax.swing.JOptionPane;

public class BattleGUI extends javax.swing.JFrame 
{
    public BattleGUI(Hero hl) 
    { 
        initComponents(); 
        hLevel = hl.getLevel();               
        Enemy e1 = new Enemy(hLevel);
        e = e1;   
        h = hl;
        enemyStartHealth = e1.getHealth();
        updateDisplay();
    }
    
    public final void updateDisplay()
    {
        jTextArea1.setText(h.getHeroStats());
        jTextArea2.setText(h.displayCurrentWeapon());
        jTextArea3.setText(e.getStats());
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        attackFists = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        attackWeapon = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        refresh = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        checkInventory = new javax.swing.JButton();
        tryToEscape = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Battle - David's RPG");
        addWindowFocusListener(new java.awt.event.WindowFocusListener()
        {
            public void windowLostFocus(java.awt.event.WindowEvent evt)
            {
            }
            public void windowGainedFocus(java.awt.event.WindowEvent evt)
            {
                formWindowGainedFocus(evt);
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                formWindowClosing(evt);
            }
        });

        jLabel3.setText("Battle Log");

        jTextArea4.setEditable(false);
        jTextArea4.setColumns(20);
        jTextArea4.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea4.setLineWrap(true);
        jTextArea4.setRows(5);
        jScrollPane4.setViewportView(jTextArea4);

        attackFists.setText("Attack with Fists");
        attackFists.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                attackFistsActionPerformed(evt);
            }
        });

        jTextArea2.setEditable(false);
        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea2.setRows(5);
        jScrollPane2.setViewportView(jTextArea2);

        attackWeapon.setText("\\/ Attack with Weapon Below \\/");
        attackWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                attackWeaponActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane2)
                    .addComponent(attackWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(attackFists, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(attackFists)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(attackWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 119, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(52, 52, 52))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 258, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        refresh.setText("Refresh");
        refresh.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                refreshActionPerformed(evt);
            }
        });

        jTextArea1.setEditable(false);
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jTextArea3.setEditable(false);
        jTextArea3.setColumns(20);
        jTextArea3.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea3.setRows(5);
        jScrollPane3.setViewportView(jTextArea3);

        jLabel1.setText("Enemy Stats");

        jLabel2.setText("Hero Stats");

        checkInventory.setText("Check Inventory");
        checkInventory.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                checkInventoryActionPerformed(evt);
            }
        });

        tryToEscape.setText("Try to escape");
        tryToEscape.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                tryToEscapeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(refresh, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(checkInventory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(tryToEscape, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                    .addComponent(jScrollPane3)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(56, 56, 56)
                                .addComponent(jLabel2))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(48, 48, 48)
                                .addComponent(jLabel1)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 219, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 138, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(refresh)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(checkInventory)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tryToEscape)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void attackFistsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackFistsActionPerformed
       
       RDN randomHero = new RDN(15);
       RDN randomEnemy = new RDN(15);
       
       int randomPoison = randomHero.RN() + (2 * h.getLevel());
       int randomHeroAttack = randomHero.RN() + h.getAttack();
       e.setAttack(e.getAttack() + randomEnemy.RN() + 10 - h.getDefense() + (h.getLevel() * 4));
       int paralyzeChanceRDN = randomHero.RN();
       
       if(e.getAttack() <= 9)
       {
           e.setAttack(10);
       }
       updateDisplay();
       switch(h.getStatus())
       {
           case "Normal":
           {
                jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");
                jTextArea4.append("\n");
                break;
           }
           case "Poison":
           {
                jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                jTextArea4.append("\n" + "You are poisoned. You lose an additonal " + randomPoison + " points of health.");
                h.setHealth(h.getHealth() - randomPoison);
                jTextArea4.append("\n");
                break;
           }
           case "Burn":
           {
                jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                e.setHealth(e.getHealth() - randomHeroAttack);
                jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                jTextArea4.append("\n" + "You are burned. You lose an additonal " + randomPoison + " points of health.");
                h.setHealth(h.getHealth() - randomPoison);
                jTextArea4.append("\n");
                break;
           }
           case "Paralyze":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    jTextArea4.append("\n" + "You are paralyzed. You cannot attack.");
                }
                else
                {
                    jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                jTextArea4.append("\n");
                break;
           }
           case "Sleep":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    jTextArea4.append("\n" + "You are asleep. You cannot attack.");
                }
                else
                {
                    jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                jTextArea4.append("\n");
                break;
           }
           case "Confusion":
           {
                if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                {
                    jTextArea4.append("\n" + "You are confused. You have hurt yourself in confusion. You loose an additional " + randomPoison + " points of health.");
                    h.setHealth(h.getHealth() - randomPoison);
                }
                else
                {
                    jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                    e.setHealth(e.getHealth() - randomHeroAttack);
                    jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                }
                
                jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                h.setHealth(h.getHealth() - e.getAttack());
                jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                jTextArea4.append("\n");
                break;
           }
       }
       
       if (h.getStatus().equals("Normal"))
       {
           RDN r2 = new RDN(6);//random status
           RDN r3 = new RDN(50);//chance to do random status
           int tempstatus;
           int temprdstatus;
           tempstatus = r2.sRN();
           temprdstatus = r3.sRN();
           String[] statuslist = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion", "Normal"};
           String status = statuslist[tempstatus];
           if (temprdstatus > 35)
           {
               h.setStatus(status);
               String sMessage;
               if(!status.equals("Normal"))
               {
               sMessage = "You have been hurt by the enemy.\n Your status is: " + "\n" + h.getStatus();
               JOptionPane.showMessageDialog(null, sMessage);
               }
           }    
       }
       
       getExp = true;

       if((e.getHealth() <= 0 && h.getHealth() >= 0) || (h.getHealth() <= 0))
       {
             boolean lose = false;
                 if(h.getHealth() <= 0)
                 {
                     lose = true;
                 }
                 win(lose);
       }
       updateDisplay();
    }//GEN-LAST:event_attackFistsActionPerformed

    private void attackWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attackWeaponActionPerformed
        
        if(h.getWeaponInventorySize() != 0)
        {
            Weapon w = h.getWeaponObject(0);
            RDN r2 = new RDN(6);
            int decWepHlth = r2.sRN();  
            
              int weaponstatchg = w.getHealth() - decWepHlth;      
             
            RDN randomHero = new RDN(15);
            RDN randomEnemy = new RDN(15);

            int randomPoison = randomHero.RN() + (2 * h.getLevel());
            int randomHeroAttack = randomHero.RN() + h.getTotalAttack();
            e.setAttack(e.getAttack() + randomEnemy.RN() + (h.getLevel() * 4));
            int paralyzeChanceRDN = randomHero.sRN();

            if(e.getAttack() <= 9)
            {
                e.setAttack(10);
            }
            updateDisplay();
            //if(w.getHealth() >= 0)
            {
                w.setHealth(w.getHealth() - decWepHlth); 
                switch(h.getStatus())
                {
                    case "Normal":
                    {
                        jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");
                        jTextArea4.append("\n");
                        break;
                   }
                   case "Poison":
                   {
                        jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        jTextArea4.append("\n" + "You are poisoned. You lose an additonal " + randomPoison + " points of health.");
                        h.setHealth(h.getHealth() - randomPoison);
                        jTextArea4.append("\n");
                        break;
                   }
                   case "Burn":
                   {
                        jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                        e.setHealth(e.getHealth() - randomHeroAttack);
                        jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        jTextArea4.append("\n" + "You are burned. You lose an additonal " + randomPoison + " points of health.");
                        h.setHealth(h.getHealth() - randomPoison);
                        jTextArea4.append("\n");
                        break;
                   }
                   case "Paralyze":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            jTextArea4.append("\n" + "You are paralyzed. You cannot attack.");
                        }
                        else
                        {
                            jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        jTextArea4.append("\n");
                        break;
                   }
                   case "Sleep":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            jTextArea4.append("\n" + "You are asleep. You cannot attack.");
                        }
                        else
                        {
                            jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        jTextArea4.append("\n");
                        break;
                   }
                   case "Confusion":
                   {
                        if(paralyzeChanceRDN == 1 || paralyzeChanceRDN == 2 || paralyzeChanceRDN == 4 || paralyzeChanceRDN == 7 || paralyzeChanceRDN == 9 || paralyzeChanceRDN == 12) 
                        {
                            jTextArea4.append("\n" + "You are confused. You have hurt yourself in confusion. You loose an additional " + randomPoison + " points of health.");
                            h.setHealth(h.getHealth() - randomPoison);
                        }
                        else
                        {
                            jTextArea4.append("\n" + h.getName() + " attacks the " + e.getName() + " and does " + randomHeroAttack + " damage.");
                            e.setHealth(e.getHealth() - randomHeroAttack);
                            jTextArea4.append("\n" + "The " + e.getName() + " now has " + e.getHealth() + " health left.");
                        }

                        jTextArea4.append("\n" + "The " + e.getName() + " attacks " + h.getName() + " and does " + e.getAttack() + " damage.");
                        h.setHealth(h.getHealth() - e.getAttack());
                        jTextArea4.append("\n" + h.getName() + " now has " + h.getHealth() + " health left.");                
                        jTextArea4.append("\n");
                        break;
                   }
               }

                if (h.getStatus().equals("Normal"))
                {
                    RDN r4 = new RDN(6);//random status
                    RDN r3 = new RDN(50);//chance to do random status
                    int tempstatus;
                    int temprdstatus;
                    tempstatus = r4.RN();
                    temprdstatus = r3.RN();
                    String[] statuslist = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion", "Normal"};
                    String status = statuslist[tempstatus];
                    if (temprdstatus > 35)
                    {
                        h.setStatus(status);
                        String sMessage;
                        if(!status.equals("Normal"))
                        {
                        sMessage = "You have been hurt by the enemy.\n Your status is: " + "\n" + h.getStatus();
                        JOptionPane.showMessageDialog(null, sMessage);
                        }
                    }    
                }
                w.setHealth(weaponstatchg);
                h.setWeaponObject(0,w);
                getExp = true;
             }
        }
        else
        {
            JOptionPane.showMessageDialog(null, "You do not have a weapon. Either attack with your fists or try to escape.");
        }

        if((e.getHealth() <= 0 && h.getHealth() >= 0) || (h.getHealth() <= 0))
             {
                 boolean lose = false;
                 if(h.getHealth() <= 0)
                 {
                     lose = true;
                 }
                 win(lose);
             }    
       updateDisplay();
       

    }//GEN-LAST:event_attackWeaponActionPerformed

    private void tryToEscapeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tryToEscapeActionPerformed
       getExp = false;
       RDN es = new RDN(11);
       int escape = es.RN();
       int newhealth;
       newhealth = e.getHealth() + escape;
       if (escape % 2 == 0)
       {
            e.setHealth(-5);
            JOptionPane.showMessageDialog(null,"You have successfully escaped...");
            enemyStartHealth = 0;
            BattleGUI.this.dispose();
            ExploreGUI eg = new ExploreGUI(h);
            eg.setLocationRelativeTo(null);
            eg.setVisible(true);
       }
       else
       {
           JOptionPane.showMessageDialog(null,"Escape attempt failed...");
           e.setHealth(newhealth);
       }
       
    }//GEN-LAST:event_tryToEscapeActionPerformed

    private void checkInventoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkInventoryActionPerformed
       NewInventoryGUI ig = new NewInventoryGUI(h);
              ig.setLocationRelativeTo(null);
              ig.setVisible(true);
    }//GEN-LAST:event_checkInventoryActionPerformed

    private void refreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshActionPerformed
        updateDisplay();
    }//GEN-LAST:event_refreshActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       updateDisplay();
    }//GEN-LAST:event_formWindowGainedFocus

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
       int result = JOptionPane.showConfirmDialog(null,"Are you sure you want to quit. If you click, \nYES, the game will end... WITHOUT SAVING. \n You must finish the battle to be able to save and quit.","Quit?", JOptionPane.YES_NO_OPTION);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
    }//GEN-LAST:event_formWindowClosing

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BattleGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BattleGUI(new Hero()).setVisible(true);
            }
        });
    }
    
    public void win(boolean lose)
    {
        int ehealth = e.getHealth();
        
        if (ehealth <= 0)
        {
             //JOptionPane.showMessageDialog(null, "The enemy is dead.");
             if (getExp == true && lose == false)
             {
                 int expold = h.getExp();
                 RDN rExp = new RDN(3);
                 int rdExp = rExp.RN();
                 int expchange = enemyStartHealth * (rdExp + 1);
                 int expnew = expold + expchange;
                 h.setExp(expchange);
                 String eMessage1 = "The enemy is dead." + "\n\nYou have gained " + expchange + " points of experience." + "\n" + "Your current exp is now at: " + expnew;
                 //JOptionPane.showMessageDialog(null, eMessage1);
                 Item item = new Item(h.getLevel());
                 eMessage1 = eMessage1 + "\n\nThe enemy dropped an item.";
//                 JOptionPane.showMessageDialog(null, iMessage1);                
                 eMessage1 = eMessage1 + "\n" + h.addItem(item);
//                 JOptionPane.showMessageDialog(null, iMessage1); 
                 RDN rCash = new RDN(10);
                 int rdCash = rCash.RN(); 
                 double mMess = Math.abs(h.getMoney() - ((h.getMoney() * .1) + ((rdCash + 1) * 1.23) + (h.getLevel() * .7) + (enemyStartHealth * .5)));
                 eMessage1 = eMessage1 + "\n\nYou have also recieved " + h.displayCurrency(mMess);
                 JOptionPane.showMessageDialog(null,eMessage1);
                 h.setMoney((h.getMoney() * .1) + ((rdCash + 1) * 1.23) + (h.getLevel() * .7) + (enemyStartHealth * .5));   
                 h.setTravels(h.getTravels() + " and won!!"+"\n-----------------------------------------\n");
                 BattleGUI.this.dispose();
                 ExploreGUI eg = new ExploreGUI(h);
                 eg.setLocationRelativeTo(null);
                 eg.setVisible(true);
             }
        }
        if(h.getHealth() <= 0 && lose == true)
        {
               JOptionPane.showMessageDialog(null, "You are dead");               
               h.setExp(-50);
               double losemoney = h.getMoney();
               double moneydec = losemoney * .25;
               losemoney = losemoney - moneydec;
               if (losemoney <= 0)
               {
                   losemoney = 0;
               }
               h.setMoney(losemoney);
               h.setHealth(200);
               DecimalFormat currency = new DecimalFormat("$0.00");
               String dMessage = "You have lost " + currency.format(moneydec) + "\n" + "You have also lost 50 exp." + "\n" + "Your health has been reset to 200.";
               JOptionPane.showMessageDialog(null, dMessage);
               h.setTravels(h.getTravels() + " and lost..."+"\n-----------------------------------------\n");
               BattleGUI.this.dispose();
               ExploreGUI eg = new ExploreGUI(h);
               eg.setLocationRelativeTo(null);
               eg.setVisible(true);
        }                              
    }
    private boolean getExp;
    private int hLevel;  
    private Hero h;
    private Enemy e;
    private int enemyStartHealth;

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton attackFists;
    private javax.swing.JButton attackWeapon;
    private javax.swing.JButton checkInventory;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JButton refresh;
    private javax.swing.JButton tryToEscape;
    // End of variables declaration//GEN-END:variables
}
