import java.io.Serializable;
import java.text.DecimalFormat;

public class Weapon implements Serializable
{
	private String name; //name of weapon
	private String mMod; //Metal Modifier
	private String wMod; //Wooden Modifer
	private int attack; //Strength of the weapon
	private int health; //Health of weapon, starts at 100% goes to 0% and break
        private double value; //Weapon Value
        private DecimalFormat Currency = new DecimalFormat("$0.00");
        private String morwmod; //metal or wooden modifier
	
	RDN rnchance = new RDN(11); //repair chance
	RDN rnrepair1 = new RDN(7); // repair multiplier 1
	RDN rnrepair2 = new RDN(5); // repair multiplier 2
	RDN rnatk = new RDN(10); // random attack
	
	private String[] weaponNames = {"Battleaxe", "Greatsword", "Maul", "Dagger", "Waraxe", "Longsword", "Mace", "Longbow", "Shortbow", "Crossbow", "Staff"}; //10 Char
	private String[] MetalModifier = {"Iron", "Steel", "Diamond", "Gold", "Wooden"};//7 Char
	private String[] WoodenModifier = {"Oak", "Elm", "Ash", "Redwood", "Pine"};//7 Char
        
	public Weapon()
	{
		RDN rn3 = new RDN(11);
		RDN rn4 = new RDN(5);
		int rdnWeapon = rn3.RN();
		int rdnWeaponMod = rn4.RN();
		name = weaponNames[rdnWeapon];
		mMod = MetalModifier[rdnWeaponMod];
		wMod = WoodenModifier[rdnWeaponMod];
                
		if (name.equals("Battleaxe") || name.equals("Greatsword") || name.equals("Maul"))
		{
			attack = 25 + rnatk.RN();
			name = mMod + " " + name;
                        value = 10.00;
                        if (mMod.equals("Iron"))
                        {
                            value += 1.00;
                            attack += 1;
                        }
                        if (mMod.equals("Steel"))
                        {
                            value += 2.00;
                            attack += 2;
                        }
                        if (mMod.equals("Diamond"))
                        {
                            value += 5.00;
                            attack +=5;
                        }
                        if (mMod.equals("Gold"))
                        {
                            value += 7.00;
                            attack -= 7;
                        }
                        if (mMod.equals("Wooden"))
                        {
                            value -= 1.00;
                            attack -= 2;
                        }
                        morwmod = "m";
                }
		if (name.equals("Dagger") || name.equals("Waraxe") || name.equals("Longsword") || name.equals("Mace"))
		{
			attack = 15 + rnatk.RN();
			name = mMod + " " + name;
                        value = 7.50;
                        if (mMod.equals("Iron"))
                        {
                            value += 1.00;
                            attack += 1;
                        }
                        if (mMod.equals("Steel"))
                        {
                            value += 2.00;
                            attack += 2;
                        }
                        if (mMod.equals("Diamond"))
                        {
                            value += 5.00;
                            attack +=5;
                        }
                        if (mMod.equals("Gold"))
                        {
                            value += 7.00;
                            attack -= 7;
                        }
                        if (mMod.equals("Wooden"))
                        {
                            value -= 1.00;
                            attack -= 2;
                        }
                            morwmod = "m";
		}
		if (name.equals("Longbow") || name.equals("Shortbow") || name.equals("Crossbow") || name.equals("Staff"))
		{
			attack = 10 + rnatk.RN();
			name = wMod + " " + name;
                        value = 5.00;
//                        {"Oak", "Elm", "Ash", "Redwood", "Pine"}
                        if(wMod.equals("Oak"))
                        {
                            value += 3.00;
                            attack += 3;
                        }
                        if(wMod.equals("Elm"))
                        {
                            value += 2.00;
                            attack += 2;
                        }
                        if(wMod.equals("Ash"))
                        {
                            value -= 2.00;
                            attack +=1;
                        }
                        if(wMod.equals("Redwood"))
                        {
                            value += 1.00;
                            attack += 1;
                        }
                        if(wMod.equals("Pine"))
                        {
                            value -= 1.00;
                            attack -= 1;
                        }
                        morwmod = "w";
		}
                
		health = 100;
	}
	
	public Weapon(String n, int a, int h, double v)
        {
            
            name = n;
            attack = a;
            health = h;
            value = v - 5 - (v/5);
            
        }
                         
        public void setName (String n)
	{
		name = n;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setAttack (int a)
	{
		attack = a;
	}
	
	public int getAttack()
	{
		return attack;
	}
	
        public void setMorW(String m)
        {
            morwmod = m;
        }
        
        public String getMorW()
        {
            return morwmod;
        }
	public void setHealth(int h)
	{
		health = h;
	}
        
        public String getAnyCurrency(double m)
        {
            return (Currency.format(m));
        }
	
	public int getHealth()
	{
		return health;
	}
        
        public void setValue(double v)
        {
                value = v;
        }
        
        public double getValue()
        {
               return value;
        }
        
        public String repairWeapon(int level)
	{
		
		int rc = rnchance.RN();
		int rm1 = rnrepair1.RN();
		int rm2 = rnrepair2.RN();
                String finalmessage;
		
		int finalstat;
		if (rm1 == 0)
			rm1 = 1;
		if (rm2 == 0);
			rm2 = 2;
		
		if (rc % 2 == 0)
		{		
			finalstat = health + (rm1 * rm2 + level);
			finalmessage = "Repair Successful, Weapon Health now at: " + finalstat;
		}
		else
		{	
			finalstat = health - (rm1 * rm2);
			finalmessage = "Repair Unsuccessful, Weapon Health now at: " + finalstat;

			if (finalstat <= 0)
			{
                            if (level < 3)
                            {
                                
                                finalmessage += "\n" + "You broke your weapon";
                            }
                            if (level < 3 && level < 10)
                            {
                                finalstat = 10;

                                finalmessage += "\n" + "Your weapon broke, but with your advanced skills you were able to bring it back to life.\nWeapon Health: " + finalstat; 
                            }
                            if (level < 11 && level < 17)
                            {
                                finalstat = 30;

                                finalmessage += "\n" + "Your weapon broke, but with your advanced skills you were able to bring it back to life.\nWeapon Health: " + finalstat; 
                            }
                            
			}
		}
		health = finalstat;
                return finalmessage;
	}	
		
	public String getWeaponStats()
	{
		return("Weapon Name: " + name + "\n" + "Weapon Attack: " + attack + "\n" + "Weapon Health: " + health + "\n" + "Value: " + getAnyCurrency(value) + "\n");
	}
}