import java.io.Serializable;
import java.text.DecimalFormat;
import java.util.Random;

public final class Item implements Serializable
{
	private String name; //name of item
	private String mod; // Modifier
	private String category; //Category
	private String itemName; //Final Item Name
	private String effect; //Item Effect
	private int modMovesCalc; //Mod: Moves Calculation
	private double modMultiCalc; //Mod: Multiplier Calculation
	private double modChancCalc; //Mod: Chance Calculation
	private int modPotioCalc; //Mod: Potions Calculation
	private String modMovesCalcText;
	private String modMultiCalcText;
	private String modChancCalcText;
	private String modPotioCalcText;
	private String itemCode; //String to keep track of and import items.
	private double itemPrice; //Starting price of item.
	private double itemValue; //value of item after use.
        private String itemValueStr;
	private String passeffect; //the effect of the item to pass to hero.
	private String statusname; //status names
        private DecimalFormat Currency = new DecimalFormat("$0.00");
	
	RDN itemCat = new RDN(4); //Item Category
	RDN itemAS = new RDN(5);//Anti-status
	RDN torp = new RDN(2); //Temporary or Permanent
	RDN itemPPE = new RDN(4);//Permanent PE
	RDN itemTPE = new RDN(2);//Temporary PE
	RDN rareChance = new RDN(8);//Rare Chance
	RDN itemRare = new RDN(3);//Rare Item
	RDN itemOther = new RDN(1);//Other Item
	RDN itemModifer = new RDN(20);//Item modifier chance, 5 items random number between 0 and 19
	
	private String[] itemCatagory = {"Anti-status", "Point Enhancers", "Rare", "Other"};//4
	private String[] asNames = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion"};//5
	private String[] ppeNames = {"Health", "Attack", "Weapon Health", "Weapon Attack"};//4
	private String[] rareNames = {"Cure All", "Experence Increase", "Level Increase"};//3
	//private String[] tpeNames = {"Temp. Atk.", "Temp. Weapon Atk."};//2
	private String[] otherNames = {"Repel"};//1
	private String[] modifers = {"Basic", "Super", "Mega", "Ultra", "Hyper"};//5
	private int[] modMoves = {20,40,80,160,320};
	private String[] modMovesText = {"20", "40", "80", "160", "320"};
	private double[] modMulti = {1.0,1.3,1.6,1.8,2.0};
	private String[] modMultiText = {"1x", "1.3x", "1.6x", "1.8x", "2x"};
	private double[] modChanc = {.40,.60,.75,.90,1.0};
	private String[] modChancText = {"40%", "60%", "75%", "90%", "100%"};
	private int[] modPotio = {10,20,40,70,110};
	private String[] modPotioText = {"10 points", "20 points", "40 points", "70 points", "110 points"};
	
	public Item()
	{
		int itemCatagoryRDN = itemCat.RN(); 
		int itemASRDN = itemAS.RN();
		//int torpRDN = torp.RN(); //Temporary or Permanent *NO TEMP ANYMORE
		int torpRDN = 0;
		int itemPPERDN = itemPPE.RN();
		int itemTPERDN = itemTPE.RN();
		int itemOtherRDN = itemOther.RN();
		int itemRareRDN = itemRare.RN();
		int rareChanceRDN = rareChance.RN();
		int itemModiferRDN = itemModifer.RN();
		
		if (itemModiferRDN <= 10)
		{
			mod = modifers[0];
			modMovesCalc = modMoves[0];
			modMultiCalc = modMulti[0];
			modChancCalc = modChanc[0];
			modPotioCalc = modPotio[0];
			modMovesCalcText = modMovesText[0];
			modMultiCalcText = modMultiText[0];
			modChancCalcText = modChancText[0];
			modPotioCalcText = modPotioText[0];
			itemCode = "#B#";
			itemPrice = 1.00;
                        itemValue = itemPrice;
                        itemValueStr = Double.toString(itemPrice);
		}
		if (itemModiferRDN >= 11 && itemModiferRDN <= 13)
		{
			mod = modifers[1];
			modMovesCalc = modMoves[1];
			modMultiCalc = modMulti[1];
			modChancCalc = modChanc[1];	
			modPotioCalc = modPotio[1];
			modMovesCalcText = modMovesText[1];
			modMultiCalcText = modMultiText[1];
			modChancCalcText = modChancText[1];
			modPotioCalcText = modPotioText[1];
			itemCode = "#S#";
			itemPrice = 7.50;
                        itemValue = itemPrice;
                        itemValueStr = Double.toString(itemPrice);
		}
		if (itemModiferRDN >= 14 && itemModiferRDN <= 16)
		{
			mod = modifers[2];
			modMovesCalc = modMoves[2];
			modMultiCalc = modMulti[2];
			modChancCalc = modChanc[2];	
			modPotioCalc = modPotio[2];
			modMovesCalcText = modMovesText[2];
			modMultiCalcText = modMultiText[2];
			modChancCalcText = modChancText[2];
			modPotioCalcText = modPotioText[2];
			itemCode = "#M#";
			itemPrice = 15.00;
                        itemValue = itemPrice;
                        itemValueStr = Double.toString(itemPrice);
		}
		if (itemModiferRDN >= 17 && itemModiferRDN <= 18)
		{
			mod = modifers[3];
			modMovesCalc = modMoves[3];
			modMultiCalc = modMulti[3];
			modChancCalc = modChanc[3];
			modPotioCalc = modPotio[3];
			modMovesCalcText = modMovesText[3];
			modMultiCalcText = modMultiText[3];
			modChancCalcText = modChancText[3];
			modPotioCalcText = modPotioText[3];
			itemCode = "#U#";
			itemPrice = 30.00;
                        itemValue = itemPrice;
                        itemValueStr = Double.toString(itemPrice);
		}
		if(itemModiferRDN == 19)
		{
			mod = modifers[4];
			modMovesCalc = modMoves[4];
			modMultiCalc = modMulti[4];
			modChancCalc = modChanc[4];
			modPotioCalc = modPotio[4];
			modMovesCalcText = modMovesText[4];
			modMultiCalcText = modMultiText[4];
			modChancCalcText = modChancText[4];
			modPotioCalcText = modPotioText[4];
			itemCode = "#H#";
			itemPrice = 60.00;
                        itemValue = itemPrice;
                        itemValueStr = Double.toString(itemPrice);
		}
					
		switch(itemCatagoryRDN)
		{
			case 0:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "A" + itemCode;
				
				switch(itemASRDN)
				{
					case 0:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "PO";
						effect = "Removes poison effect. " + modChancCalcText + " chance.";
						break;
					}
					case 1:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "BU";
						effect = "Removes burn effect. " + modChancCalcText + " chance.";
						break;
					}
					case 2:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "PA";
						effect = "Removes paralysis effect. " + modChancCalcText + " chance.";
						break;
					}
					case 3:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "SL";
						effect = "Removes sleep effect. " + modChancCalcText + " chance.";
						break;
					}
					case 4:
					{
						name = asNames[itemASRDN];
						itemCode = itemCode + "CO";
						effect = "Removes confusion effect. " + modChancCalcText + " chance.";
						break;
					}
				}
				name = "Anti-" + name;
				itemName = mod + " " + name;
				break;
			}
			case 1:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "P" + itemCode;
				
				switch(torpRDN)
				{
					case 0:
					{
						switch(itemPPERDN)
						{
							case 0:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "HE";
								effect = "Restores health by " + modPotioCalcText + ".";
								break;
							}
							case 1:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "AP";
								effect = "Increase attack by " + modPotioCalcText + ".";
								break;
							}
							case 2:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "WH";
								effect = "Restores weapon health by " + modPotioCalcText + ".";
								break;
							}
							case 3:
							{
								name = ppeNames[itemPPERDN];
								itemCode = itemCode + "WP";
								effect = "Increase weapon attack by " + modPotioCalcText + ".";
								break;
							}
						}
					
						break;
					}
				}
				name = name + " " + "Increase";
				itemName = mod + " " + name;
				break;
			}
			case 2:
			{
				category = itemCatagory[itemCatagoryRDN];
				
			
				if(rareChanceRDN == 1 || rareChanceRDN == 2 || rareChanceRDN == 4)
				{
					itemCode = "R" + itemCode;
					switch(itemRareRDN)
					{
						case 0:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "CA";
							effect = "Removes all negative effects.";
							itemName = name;
							break;
						}
						case 1:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "EI";
							effect = "Increase experence by " + modPotioCalcText + ".";
							itemName = mod + " " + name;
							break;
						}
						case 2:
						{
							name = rareNames[itemRareRDN];
							itemCode = itemCode + "LI";
							effect = modChancCalcText + " chance to increase level by 1.";
							itemName = name;
							break;
						}
						
					}
				}
				else if(rareChanceRDN == 0 || rareChanceRDN == 3 || rareChanceRDN == 5 || rareChanceRDN == 6 || rareChanceRDN == 7)
				{
					itemCode = "P" + itemCode;
					name = ppeNames[0] + " Increase";
					itemCode = itemCode + "HE";
					effect = "Restores health by " + modPotioCalcText + ".";
					itemName = mod + " " + name;
				}
				
				break;
			}
			case 3:
			{
				category = itemCatagory[itemCatagoryRDN];
				itemCode = "O" + itemCode;
				
				switch(itemOtherRDN)
				{
					case 0:
					{
						name = otherNames[itemOtherRDN];
						itemCode = itemCode + "RE";
						effect = "Repel attacks for " + modMovesCalcText + " steps.";
						itemName = mod + " " + name;
						break;
					}
				}
				
				break;
			}
		}
		
		/*do
		{
			itemName = itemName + " ";
		}
		while(itemName.length() <= 33);		
		
		do
		{
			category = category + " ";
		}
		while(category.length() <= 19);*/
	}

        public Item(String name, String effect, String ic, double value)
        {
            setName(name);
            setEffect(effect);
            setIC(ic);
            setValue(value - 5 - (value/5));
            
        }
        
	public Item(String ic)
	{
		String[] str_array = ic.split("#");
		String tmpCat = str_array[0];
		String tmpMod = str_array[1];
		String tmpName = str_array[2];
		double totalcalc =  0.0;
		double calc1 = 0.0;
		double calc2 = 0.0;
		int calc3 = 0;
		
		
		switch(tmpCat)
		{
			case "N":
			{
				System.out.println("No item to use");
				setCategory("NULL");
				setName("NULL");
				break;
			}
			case "A":
			{
				System.out.println("Anti");
				setCategory("Anti-status");
				switch(tmpName)
				{
					case "PO":
					{
						setName("Poison");
						switch(tmpMod)
						{
							case "B":
							{
								calc1 = modChanc[0];
								break;
							}
							case "S":
							{
								calc1 = modChanc[1];
								break;
							}
							case "M":
							{
								calc1 = modChanc[2];
								break;
							}
							case "U":
							{
								calc1 = modChanc[3];
								break;
							}
							case "H":
							{
								calc1 = modChanc[4];
								break;
							}
						}
						break;
					}		
			
					case "BU":
					{
						setName("Burn");
						switch(tmpMod)
						{
							case "B":
							{
								calc1 = modChanc[0];
								break;
							}
							case "S":
							{
								calc1 = modChanc[1];
								break;
							}
							case "M":
							{
								calc1 = modChanc[2];
								break;
							}
							case "U":
							{
								calc1 = modChanc[3];
								break;
							}
							case "H":
							{
								calc1 = modChanc[4];
								break;
							}
						}
						
						break;					
					
					}
					case "PA":
					{
						setName("Paralysis");
						switch(tmpMod)
						{
							case "B":
							{
								calc1 = modChanc[0];
								break;
							}
							case "S":
							{
								calc1 = modChanc[1];
								break;
							}
							case "M":
							{
								calc1 = modChanc[2];
								break;
							}
							case "U":
							{
								calc1 = modChanc[3];
								break;
							}
							case "H":
							{
								calc1 = modChanc[4];
								break;
							}
						}
						
						break;					
					}
					case "SL":
					{
						setName("Sleep");
						switch(tmpMod)
						{
							case "B":
							{
								calc1 = modChanc[0];
								break;
							}
							case "S":
							{
								calc1 = modChanc[1];
								break;
							}
							case "M":
							{
								calc1 = modChanc[2];
								break;
							}
							case "U":
							{
								calc1 = modChanc[3];
								break;
							}
							case "H":
							{
								calc1 = modChanc[4];
								break;
							}
						}
						
						break;					
					}
					case "CO":
					{
						setName("Confusion");
						switch(tmpMod)
						{
							case "B":
							{
								calc1 = modChanc[0];
								break;
							}
							case "S":
							{
								calc1 = modChanc[1];
								break;
							}
							case "M":
							{
								calc1 = modChanc[2];
								break;
							}
							case "U":
							{
								calc1 = modChanc[3];
								break;
							}
							case "H":
							{
								calc1 = modChanc[4];
								break;
							}
						}
						break;					
					}
					}
					Random r = new Random();
					Float chance1 = r.nextFloat();
					if (chance1 <= calc1)
					{
						passeffect = "TRUE";
					}
					else
					{
						passeffect = "FALSE";
					}
					
				
				break;
			}
			case "P":
			{
				System.out.println("Point Enhancers");
				setCategory("Point Enhancers");
				switch(tmpName)
				{
					case "HE":
					{
						switch(tmpMod)
						{
							case "B":
							{
								calc3 = modPotio[0];
								break;
							}
							case "S":
							{
								calc3 = modPotio[1];
								break;
							}
							case "M":
							{
								calc3 = modPotio[2];
								break;
							}
							case "U":
							{
								calc3 = modPotio[3];
								break;
							}
							case "H":
							{
								calc3 = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(calc3);
						setName("Potion");
						break;
					}
					case "AP":
					{
						switch(tmpMod)
						{
							case "B":
							{
								calc3 = modPotio[0];
								break;
							}
							case "S":
							{
								calc3 = modPotio[1];
								break;
							}
							case "M":
							{
								calc3 = modPotio[2];
								break;
							}
							case "U":
							{
								calc3 = modPotio[3];
								break;
							}
							case "H":
							{
								calc3 = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(calc3);
						setName("Attack");
						break;
					}
					case "WH":
					{
						switch(tmpMod)
						{
							case "B":
							{
								calc3 = modPotio[0];
								break;
							}
							case "S":
							{
								calc3 = modPotio[1];
								break;
							}
							case "M":
							{
								calc3 = modPotio[2];
								break;
							}
							case "U":
							{
								calc3 = modPotio[3];
								break;
							}
							case "H":
							{
								calc3 = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(calc3);
						setName("WeaponHealth");
						break;
					}
					case "WP":
					{
						switch(tmpMod)
						{
							case "B":
							{
								calc3 = modPotio[0];
								break;
							}
							case "S":
							{
								calc3 = modPotio[1];
								break;
							}
							case "M":
							{
								calc3 = modPotio[2];
								break;
							}
							case "U":
							{
								calc3 = modPotio[3];
								break;
							}
							case "H":
							{
								calc3 = modPotio[4];
								break;
							}
						}
						passeffect = Integer.toString(calc3);
						setName("WeaponAttack");
						break;
					}
				}
				
				
				break;
			}
			case "R":
			{
				//System.out.println("Rare");
				setCategory("Rare");
				//passeffect = "NO EFFECT YET";
                                switch (tmpName)
                                {
                                    case "CA":
                                    {    
                                        switch(tmpMod)
                                        {
                                              case "B":
                                              {
                                                        calc2 = modChanc[0];
                                                        break;
                                                }
                                                case "S":
                                                {
                                                        calc2 = modChanc[1];
                                                        break;
                                                }
                                                case "M":
                                                {
                                                        calc2 = modChanc[2];
                                                        break;
                                                }
                                                case "U":
                                                {
                                                        calc2 = modChanc[3];
                                                        break;
                                                }
                                                case "H":
                                                {
                                                        calc2 = modChanc[4];
                                                        break;
                                                }
                                        }
                                        Random r = new Random();
					Float chance1 = r.nextFloat();
					if (chance1 <= calc1)
					{
						passeffect = "TRUE";
					}
					else
					{
						passeffect = "FALSE";
					}
                                            //passeffect = Double.toString(calc2);
                                            setName("CureAll");
                                            break;
                                    }
                                    case "EI":
                                    {    
                                        switch(tmpMod)
                                        {
                                              case "B":
                                              {
                                                        calc3 = modMoves[0];
                                                        break;
                                                }
                                                case "S":
                                                {
                                                        calc3 = modMoves[1];
                                                        break;
                                                }
                                                case "M":
                                                {
                                                        calc3 = modMoves[2];
                                                        break;
                                                }
                                                case "U":
                                                {
                                                        calc3 = modMoves[3];
                                                        break;
                                                }
                                                case "H":
                                                {
                                                        calc3 = modMoves[4];
                                                        break;
                                                }
                                        }
                                            passeffect = Double.toString(calc2);
                                            setName("ExpInc");
                                            break;
                                    }
                                    case "LI":
                                    {    
                                        switch(tmpMod)
                                        {
                                              case "B":
                                              {
                                                        calc2 = modChanc[0] + .25;
                                                        break;
                                                }
                                                case "S":
                                                {
                                                        calc2 = modChanc[1] + .10;
                                                        break;
                                                }
                                                case "M":
                                                {
                                                        calc2 = modChanc[2];
                                                        break;
                                                }
                                                case "U":
                                                {
                                                        calc2 = modChanc[3];
                                                        break;
                                                }
                                                case "H":
                                                {
                                                        calc2 = modChanc[4];
                                                        break;
                                                }
                                        }
                                            passeffect = Double.toString(calc2);
                                            setName("LevelIncrease");
                                            break;
                                    }
                                }
				break;
			}
			case "O":
			{
				System.out.println("Other");
				setCategory("Other");
				passeffect = "NO EFFECT YET";
				break;
			}
		}
		
		//System.out.println(calc1);
	}					

	
	public void setName (String n)
	{
		name = n;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setPassEffect(String pe)
	{
		passeffect = pe;
	}
	
	public String getPassEffect()
	{
		return passeffect;
	}
	
	public String getAnyCurrency(double m)
        {
            return (Currency.format(m));
        }
        
	public void setMod (String m)
	{
		mod = m;
	}
	
	public String getMod()
	{
		return mod;
	}
	
	public void setCategory(String c)
	{
		category = c;
	}
	
	public String getCategory()
	{
		return category;
	}
	
	public String getItemName()
	{
		return itemName;
	}
	
	public void setStatusName(int sn)
	{
		statusname = asNames[sn];
	}
	public String getStatusName()
	{
		return statusname;
	}
	
	public void setEffect(String e)
	{
		effect = e;
	}
	
	public String getEffect()
	{
		return effect;
	}
	
	public void setMoves(int m)
	{
		modMovesCalc = m;
	}
	
	public int getMoves()
	{
		return modMovesCalc;
	}
	
	public void setIC(String ic)
	{
		itemCode = ic;
	}
	
	public String getIC()
	{
		return itemCode;
	}
	public double getPrice()
	{
		return itemPrice;
	}
	public double getValue()
	{
		return itemValue;
	}
	public void setPrice(double p)
	{
		itemPrice = p;
	}
	public void setValue(double v)
	{
		itemValue = v;
	}
        
        public String getValueStr(double v)
        {
            String valuestr = Double.toString(v);
            return valuestr;
        }
	
	public String itemToString(String i, String e, String ic, String v)
	{
		return(i + "_" + e + "_" + ic + "_" + v);
	}
	
	public void itemFromString(String ifs)
	{
		String[] str_array = ifs.split("_");
		itemName = str_array[0];
		//category = str_array[1];
		effect = str_array[1];
		itemCode = str_array[2];
                itemValueStr = str_array[3];
	}
		
	public String getItemStats()
	{
		return("Item: " + itemName + "\n" + "Item Category: " + category + "\nItem Effect: " + effect + "\nMove: " + modMovesCalc);
	}
	
	public String displayStoreItems()
	{
		return("Item: " + itemName + "Item Description: " + effect + "\nItem Price: " + getAnyCurrency(itemPrice));
	}
}