import java.awt.Point;
import java.io.Serializable;
import java.text.*;
import java.util.ArrayList;
import javax.swing.JOptionPane;

public class Hero implements Serializable
{
    private String name; //default values
    private int health; //300
    private int attack; //10
    private int defense; //10
    private int exp; //0
    private int level; //Level 1
    private String status; //Normal
    private double money; //$50.00
    private int totalattack; //weapon attack + attack
    private int bonusWeaponInventory;
    private int bonusItemInventory;
    private Point heroLocation;
    private String heroPlace;
    private String travels;
    private int weaponInventoryCounter;
    private int itemInventoryCounter;
    
    private final DecimalFormat Currency = new DecimalFormat("$0.00");
    
    private ArrayList<Weapon> weaponInventory = new ArrayList<>();
    private ArrayList<Item> itemInventory = new ArrayList<>();
    private ArrayList<Weapon> storeWeapons = new ArrayList<>();
    private ArrayList<Item> storeItems = new ArrayList<>();
    
    Locations l = new Locations();
     
    public Hero()
    {
        name = "";
        health = 300;
        attack = 10;
        defense = 10;
        exp = 0;
        level = 1;
        status = "Normal";
        money = 50.00;
        bonusWeaponInventory = 0;
        bonusItemInventory = 0;
        weaponInventoryCounter = 6;
        itemInventoryCounter = 6;
        setStartWeapon();
        getTotalAttack();
        int x = 300;
        int y = 483;
        heroLocation = new Point(x,y);
        String hp = getHeroPlace();
        heroPlace = hp;
        Village v0 = l.getVillage(0);
        v0.setVisited(true);
        l.setVillage(v0, 0);
        travels = "";
        
    }
    
    // <editor-fold defaultstate="collapsed" desc="SETS">
    
    public void setName(String n)
    {
        name = n;
    }
    
    public void setWeaponInventoryCounter(int i)
    {
        weaponInventoryCounter = i;
    }
    
    public void setItemInventoryCounter(int i)
    {
        itemInventoryCounter = i;
    }
    
    public void setTravels(String t)
    {
        travels = t;
    }
    
    public void setHealth(int h)
    {
        health = h;
    }
    
    public void setAttack(int a)
    {
        attack = a;
    }
    
    public void setDefense(int d)
    {
        defense = d;
    }
    
    // <editor-fold defaultstate="collapsed" desc="Set Exp Code">
    public void setExp(int e)
    {
        
        int oldatk = attack;
        int newatk;
        int expold = exp;
        int expnew = expold + e;
        exp = expnew;

        if (expold < 500 && expnew > 501 )//add attack and defense upgrade later
        {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 2.\nYou have unlocked an extra weapon slot.\nYou also get +100 health.");
            setHealth(health + 100);
            newatk = oldatk + 50;
            setAttack(newatk);
            setLevel(2);
            defense =+ 5;
            weaponInventoryCounter = weaponInventoryCounter + 1;
        }
        
        if (expold < 2500 && expnew > 2501)//add attack and defense upgrade later
        {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 3.\nYou have unlocked an extra weapon slot.\nYou also get +100 health.");
            setHealth(health + 100);
            newatk = oldatk + 50;
            setAttack(newatk);
            setLevel(3);
            defense =+ 5;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
        }
        
        if (expold < 4500 && expnew > 4501)//add attack and defense upgrade later
        {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 4.\nYou have unlocked an extra weapon slot.\nYou also get +100 health.");
            setHealth(health + 100);
            newatk = oldatk + 50;
            setAttack(newatk);
            setLevel(4);
            defense =+ 5;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
        }
        
        if (expold < 8000 && expnew > 8001)//add attack and defense upgrade later
        {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 5.\nYou have unlocked an extra weapon slot.\nYou also get +100 health.");
            setHealth(health + 100);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(5);
            defense =+ 10;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
        }
        
        if (expold < 15500 && expnew > 15501)//add attack and defense upgrade later
        {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 6.\nYou have unlocked an extra weapon slot.\nYou also get +100 health.");
            setHealth(health + 100);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(6);
            defense =+ 10;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
                     
       if (expold < 27000 && expnew > 27001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 7.\nYou have unlocked an extra weapon slot.\nYou also get +200 health.");
            setHealth(health + 200);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(7);
            defense =+ 10;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       
       if (expold < 50000 && expnew > 50001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 8.\nYou have unlocked an extra weapon slot.\nYou also get +200 health.");
            setHealth(health + 200);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(8);
            defense =+ 10;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       
       if (expold < 75000 && expnew > 75001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 9.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 300);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(9);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       
       if (expold < 105000 && expnew > 105001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 10.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 300);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(10);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 130000 && expnew > 130001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 11.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 300);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(11);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 160000 && expnew > 160001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 12.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 300);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(12);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 200000 && expnew > 200001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 13.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 500);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(13);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 250000 && expnew > 250001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 14.\nYou have unlocked an extra weapon slot.\nYou also get +300 health.");
            setHealth(health + 500);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(14);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 310000 && expnew > 310001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 15.\nYou have unlocked an extra weapon slot.\nYou also get +1000 health.");
            setHealth(health + 1000);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(15);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
       if (expold < 380000 && expnew > 380001)//add attack and defense upgrade later
       {
            JOptionPane.showMessageDialog(null,"Congratulations, you have reached Level 16.\nYou have unlocked an extra weapon slot.\nYou also get +1000 health.");
            setHealth(health + 1000);
            newatk = oldatk + 150;
            setAttack(newatk);
            setLevel(16);
            defense =+ 20;
            weaponInventoryCounter = weaponInventoryCounter + 1; itemInventoryCounter = itemInventoryCounter + 2;
       }
    } // </editor-fold>
    
    public void setLevel(int l)
    {
        level = l;
    }
    
    public void setStatus(String s)
    {
        status = s;
    }
    
    public void setMoney(double m)
    {
        money = m;
    }
    
    public void setBonusWeaponInventory(int b)
    {
        bonusWeaponInventory = b;
    }
    
    public void setBonusItemInventory(int b)
    {
        bonusItemInventory = b;
    }
    
    public final void setStartWeapon()
    {
        Weapon w = new Weapon("Wooden Dagger", 12, 100, 10.00);
        weaponInventory.add(0,w);
        weaponInventoryCounter = weaponInventoryCounter - 1;
    }
    
    public void setHeroLocationPoint(Point xy)
    {
        heroLocation.setLocation(xy);
    }
    public void setHeroLocationXY(double x, double y)
    {
        heroLocation.setLocation(x,y);
    }
    public void setHeroLocationX(int x)
    {
        heroLocation.x = x;
    }
    public void setHeroLocationY(int y)
    {
        heroLocation.y = y;
    }
    
    public void setHeroPlaceName(String pn)
    {
        heroPlace = pn;
    }
    //</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="GETS">
    public String getName()
    {
        return name;
    }
    
    public String getTravels()
    {
        return travels;
    }
    
    public int getWeaponInventoryCounter()
    {
        return weaponInventoryCounter;
    }
    
    public int getItemInventoryCounter()
    {
        return itemInventoryCounter;
    }
    
    public int getHealth()
    {
        return health;
    }
    
    public int getAttack()
    {
        return attack;
    }
    
    public int getDefense()
    {
        return defense;
    }
    
    public int getExp()
    {
        return exp;
    }
    
    public int getLevel()
    {
        return level;
    }
    
    public String getStatus()
    {
        return status;
    }
    
    public double getMoney()
    {
        return money;
    }
    
    public Locations getLocationObject()
    {
        return l;
    }
    
    public int getBonusWeaponInventory()
    {
        return bonusWeaponInventory;
    }
    
    public int getBonusItemInventory()
    {
        return bonusItemInventory;
    }
    
    public int getWeaponInventorySize()
    {
        return weaponInventory.size();
    }
    
    public int getItemInventorySize()
    {
        return itemInventory.size();
    }
    
    public int getStoreWeaponsSize()
    {
        return storeWeapons.size();
    }
    
    public int getStoreItemsSize()
    {
        return storeItems.size();
    }
    
    public Point getHeroLocationPoint()
    {
        return heroLocation;
    }
    
    public double getHeroLocationX()
    {
        return heroLocation.getX();
    }
    
    public double getHeroLocationY()
    {
        return heroLocation.getY();
    }
    
    public String getHeroPlaceName()
    {
        return heroPlace;
    }
    
    public final int getTotalAttack()
    {
        try
        { 
            Weapon w = weaponInventory.get(0);
            totalattack = attack + w.getAttack();
        }
        catch(IndexOutOfBoundsException ioobe)
        {
        }
        return totalattack;
    }
    
    public String getHeroStats()
    {
        getTotalAttack();
        return("Name: " + name + "\n" + "Health: " + health + "\n" + "Attack: " + attack + "\n" + "Attack with Weapon: " + totalattack + "\n" + "Defense: " + defense + "\n" + "Status: " + status + "\n" + "Exp: " + exp + "\n" + "Level: " + level + "\n" + "Money: " + displayCurrency(money));
    }//</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="WEAPON INVENTORY MANAGEMENT">
    
    // <editor-fold defaultstate="collapsed" desc="addWeapon Code">
    public String addWeapon(Weapon w)
    {
        String finalmessage;
        if(level == 1)
        {
            if(weaponInventory.size() <= (5 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
                weaponInventoryCounter = weaponInventoryCounter - 1;
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 2)
        {
            if(weaponInventory.size() <= (6 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 3)
        {
            if(weaponInventory.size() <= (7 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 4)
        {
            if(weaponInventory.size() <= (8 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 5)
        {
            if(weaponInventory.size() <= (9 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 6)
        {
            if(weaponInventory.size() <= (10 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 7)
        {
            if(weaponInventory.size() <= (11 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 8)
        {
            if(weaponInventory.size() <= (12 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 9)
        {
            if(weaponInventory.size() <= (13 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 10)
        {
            if(weaponInventory.size() <= (14 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 11)
        {
            if(weaponInventory.size() <= (14 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 12)
        {
            if(weaponInventory.size() <= (15 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 13)
        {
            if(weaponInventory.size() <= (16 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 14)
        {
            if(weaponInventory.size() <= (17 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 15)
        {
            if(weaponInventory.size() <= (18 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 16)
        {
            if(weaponInventory.size() <= (19 + bonusWeaponInventory))
            {
                weaponInventory.add(w);
                weaponInventoryCounter = weaponInventoryCounter - 1;
                finalmessage = "A weapon with the stats:\n" + w.getWeaponStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else
        {
            finalmessage = "Inventory Full";
        }
        if(!finalmessage.equals("Inventory Full"))
        {
            finalmessage += "\n You now have " + weaponInventoryCounter + " slots left.";
        }
        
        return finalmessage;
    }//</editor-fold>
    
    public Weapon getWeaponObject(int i)
    {
        return weaponInventory.get(i);
    }
    
    public Weapon getStoreWeaponObject(int i)
    {
        return storeWeapons.get(i);
    }
    
    public void setWeaponObject(int i, Weapon w)
    {
        if(w.getHealth() > 0)
        {
            weaponInventory.set(i, w);
        }
        else
        {
            destroyWeapon(i);
        }
        
    }
    
    public void destroyWeapon(int i)
    {
        weaponInventory.remove(i);
        weaponInventoryCounter = weaponInventoryCounter + 1;
        JOptionPane.showMessageDialog(null, "Weapon Removed.");
    }
    
    public void repairWeapon()
    {
        try
        {
            Weapon w = getWeaponObject(0);
            String repair = w.repairWeapon(level);
            JOptionPane.showMessageDialog(null, repair);
            if (w.getHealth() <= 0)
            {
                JOptionPane.showMessageDialog(null, "The weapon will now be removed from your inventory.");
                destroyWeapon(0);

            }
            else
            {
                setWeaponObject(0, w);
            }
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            JOptionPane.showMessageDialog(null, "You have no weapons to repair.");
        }
    }
    //</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="ITEM INVENTORY MANAGEMENT">
   
    // <editor-fold defaultstate="collapsed" desc="addItem Code">
    public String addItem(Item i)
    {
        String finalmessage;
        if(level == 1)
        {
            if(itemInventory.size() <= (5 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 2)
        {
            if(itemInventory.size() <= (7 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 3)
        {
            if(itemInventory.size() <= (9 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 4)
        {
            if(itemInventory.size() <= (11 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 5)
        {
            if(itemInventory.size() <= (13 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 6)
        {
            if(itemInventory.size() <= (15 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 7)
        {
            if(itemInventory.size() <= (17 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }    
        else if(level == 8)
        {
            if(itemInventory.size() <= (19 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }     
        else if(level == 9)
        {
            if(itemInventory.size() <= (21 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 10)
        {
            if(itemInventory.size() <= (23 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "An item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
                else if(level == 12)
        {
            if(itemInventory.size() <= (25 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "A item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 13)
        {
            if(itemInventory.size() <= (27 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "A item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 14)
        {
            if(itemInventory.size() <= (29 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "A item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 15)
        {
            if(itemInventory.size() <= (31 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "A item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else if(level == 16)
        {
            if(itemInventory.size() <= (33 + bonusItemInventory))
            {
                itemInventory.add(i); itemInventoryCounter = itemInventoryCounter - 1;
                finalmessage = "A item with the stats:\n" + i.getItemStats() + "\nHas been added to your inventory.";
            }
            else
            {
                finalmessage = "Inventory Full";
            }
        }
        else
        {
            finalmessage = "Inventory Full";
        }
        if(!finalmessage.equals("Inventory Full"))
        {
            finalmessage += "\n You now have " + weaponInventoryCounter + " slots left.";
        }
                
        return finalmessage;
    }//</editor-fold>
    
    public void addItemAt(int z, Item i)
    {
        itemInventory.add(z, i);
    }
    
    public Item getItemObject(int i)
    {
        return itemInventory.get(i);
    }
    
    public Item getStoreItemObject(int i)
    {
        return storeItems.get(i);
    }
    
    public void setItemObject(int z, Item i)
    {
       itemInventory.set(z, i);
    }
    
    public void destroyItem(int i)
    {
        itemInventory.remove(i);
        itemInventoryCounter = itemInventoryCounter + 1;
        JOptionPane.showMessageDialog(null, "Item Removed.");
    }
    
    public void upgradeWeaponHealth(int wh)
    {
        String message;
        try
        {
            Weapon w = weaponInventory.get(0);
            w.setHealth(w.getHealth() + wh);
            weaponInventory.set(0,w);
            
            message = "Health increase successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon in that slot. Please choose another number.";
        }
        JOptionPane.showMessageDialog(null,message);
    }
    
    public void upgradeWeaponAttack(int wa)
    {
        String message;
        try
        {
            Weapon w = weaponInventory.get(0);
            w.setAttack(w.getAttack() + wa);
            weaponInventory.set(0,w);
            
            message = "Attack increase successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon in that slot. Please choose another number.";
        }
        JOptionPane.showMessageDialog(null,message);
    }
    
    public void clearItemInventory()
    {
        itemInventory.clear();
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="BATTLE METHODS">

    //</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="TOOLS">
    public String displayCurrency(double m)
    {
        return (Currency.format(m));
    }//</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="INVENTORY METHODS">
    public String switchWeapon(int i)
    {
        String message;
        try
        {
            Weapon w1 = weaponInventory.get(0);
            Weapon w2 = weaponInventory.get(i);
            weaponInventory.set(0,w2);
            weaponInventory.set(i,w1);
            message = "Switch Successful";
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            message = "There is no weapon in that slot. Please choose another number.";
        }
        return message;
    }//</editor-fold>
   
    // <editor-fold defaultstate="collapsed" desc="DISPLAY METHODS">     
   
    public String displayCurrentWeapon()
    {
        String finalmessage;
        try
        {
            Weapon w = weaponInventory.get(0);
            finalmessage = w.getWeaponStats();
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = "You have no weapons. \nPurchase a new one \nfrom the store.";
        }
        return finalmessage;
    }
    
    public String displayWeaponInventoryNumbers()
    {
        String finalmessage = "";
        if (weaponInventory.size() >= 1)
        {
            for (int i = 0; i < weaponInventory.size(); i++)
            {
                finalmessage += Integer.toString(i+1) + "\n";
            }
        }
        return finalmessage;
    }
    
    public String displayWeaponInventoryNames()
    {
        String finalmessage = "";
        if (weaponInventory.size() >= 1)
        {
            for (int i = 0; i < weaponInventory.size(); i++)
            {
                Weapon w = weaponInventory.get(i);
                finalmessage += w.getName() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponInventoryAttack()
    {
        String finalmessage = "";
        if (weaponInventory.size() >= 1)
        {
            for (int i = 0; i < weaponInventory.size(); i++)
            {
                Weapon w = weaponInventory.get(i);
                finalmessage += w.getAttack() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponInventoryHealth()
    {
        String finalmessage = "";
        if (weaponInventory.size() >= 1)
        {
            for (int i = 0; i < weaponInventory.size(); i++)
            {
                Weapon w = weaponInventory.get(i);
                finalmessage += w.getHealth() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponInventoryValue()
    {
        String finalmessage = "";
        if (weaponInventory.size() >= 1)
        {
            for (int i = 0; i < weaponInventory.size(); i++)
            {
                Weapon w = weaponInventory.get(i);
                finalmessage += displayCurrency(w.getValue()) + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponStoreNumbers()
    {
        String finalmessage = "";
        if (storeWeapons.size() >= 1)
        {
            for (int i = 0; i < storeWeapons.size(); i++)
            {
                finalmessage += Integer.toString(i + 1) + "\n";
            }
        }
        return finalmessage;
    }
    
    public String displayWeaponStoreNames()
    {
        String finalmessage = "";
        if (storeWeapons.size() >= 1)
        {
            for (int i = 0; i < storeWeapons.size(); i++)
            {
                Weapon w = storeWeapons.get(i);
                finalmessage += w.getName() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponStoreAttack()
    {
        String finalmessage = "";
        if (storeWeapons.size() >= 1)
        {
            for (int i = 0; i < storeWeapons.size(); i++)
            {
                Weapon w = storeWeapons.get(i);
                finalmessage += w.getAttack() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponStoreHealth()
    {
        String finalmessage = "";
        if (storeWeapons.size() >= 1)
        {
            for (int i = 0; i < storeWeapons.size(); i++)
            {
                Weapon w = storeWeapons.get(i);
                finalmessage += w.getHealth() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayWeaponStoreValue()
    {
        String finalmessage = "";
        if (storeWeapons.size() >= 1)
        {
            for (int i = 0; i < storeWeapons.size(); i++)
            {
                Weapon w = storeWeapons.get(i);
                finalmessage += displayCurrency(w.getValue()) + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemInventoryNumbers()
    {
        String finalmessage = "";
        if (itemInventory.size() >= 1)
        {
            for (int i = 0; i < itemInventory.size(); i++)
            {
                finalmessage += Integer.toString(i+1) + "\n";
            }
        }
        return finalmessage;
    }
    
    public String displayItemInventoryNames()
    {
        String finalmessage = "";
        if (itemInventory.size() >= 1)
        {
            for (int i = 0; i < itemInventory.size(); i++)
            {
                Item z = itemInventory.get(i);
                finalmessage += z.getItemName() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemInventoryDescription()
    {
        String finalmessage = "";
        if (itemInventory.size() >= 1)
        {
            for (int i = 0; i < itemInventory.size(); i++)
            {
                Item z = itemInventory.get(i);
                finalmessage += z.getEffect() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemInventoryValue()
    {
        String finalmessage = "";
        if (itemInventory.size() >= 1)
        {
            for (int i = 0; i < itemInventory.size(); i++)
            {
                Item z = itemInventory.get(i);
                finalmessage += displayCurrency(z.getValue()) + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemStoreNumbers()
    {
        String finalmessage = "";
        if (storeItems.size() >= 1)
        {
            for (int i = 0; i < storeItems.size(); i++)
            {
                finalmessage += Integer.toString(i + 1) + "\n";
            }
        }
        return finalmessage;
    }
    
    public String displayItemStoreNames()
    {
        String finalmessage = "";
        if (storeItems.size() >= 1)
        {
            for (int i = 0; i < storeItems.size(); i++)
            {
                Item z = storeItems.get(i);
                finalmessage += z.getItemName() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemStoreDescription()
    {
        String finalmessage = "";
        if (storeItems.size() >= 1)
        {
            for (int i = 0; i < storeItems.size(); i++)
            {
                Item z = storeItems.get(i);
                finalmessage += z.getEffect() + "\n";
            }
        }
        
        return finalmessage;
    }
    
    public String displayItemStoreValue()
    {
        String finalmessage = "";
        if (storeItems.size() >= 1)
        {
            for (int i = 0; i < storeItems.size(); i++)
            {
                Item z = storeItems.get(i);
                finalmessage += displayCurrency(z.getValue()) + "\n";
            }
        }
        
        return finalmessage;
    }    
    //</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="STORE METHODS">
    public void stockWeaponStore(int n)
    {
        storeWeapons.clear();
        for (int i = 0; i < n; i++)
        {
            Weapon w = new Weapon();
            w.setValue(w.getValue() + 5 + (w.getValue() * .85 ) * (2 * level * .99));
            w.setAttack(w.getAttack() + (level * 4));
            storeWeapons.add(w);
        }
    }
    
    public void stockItemStore(int n)
    {
        storeItems.clear();
        for (int z = 0; z < n; z++)
        {
            Item i = new Item(level);
            i.setValue(i.getValue() + 5 + /*(i.getValue() * .85 )*/ (2 * level * .99));
            storeItems.add(i);
        }
    }
    
    public String buyWeapon(int a)
    {
        String finalmessage = "";
        try
        {
            Weapon w = storeWeapons.get(a);
            if((money - w.getValue()) > 0)
            {
                if(!addWeapon(w).equals("Inventory Full"))
                {
                    money = money - w.getValue();
                    w.setValue(w.getValue() - 10 - (level * .75));
                    storeWeapons.remove(a);
                    finalmessage = "Weapon purchased";
                   // weaponInventoryCounter = weaponInventoryCounter - 1;
                }
                else
                {
                    finalmessage = "Inventory Full";
                }
            }
            else
            {
                finalmessage = "Cannot afford the weapon.";
            }
        }
        catch(NullPointerException npe)
        {
            finalmessage = ("Please select a different weapon.");
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = ("Please select an item.");
        }
        
        return finalmessage;
    }
    
    public String buyItem(int a)
    {
        String finalmessage = "";
        try
        {
            Item i = storeItems.get(a);
            if((money - i.getValue()) > 0)
            {
                if(!addItem(i).equals("Inventory Full"))
                {        
                    money = money - i.getValue();
                    double nValue = i.getValue() - 10;
                    if (nValue <= 0)
                    {
                        nValue = 5;
                    }
                    i.setValue(nValue);
                    storeItems.remove(a);
                    finalmessage = "Item purchased";
                    //itemInventoryCounter = itemInventoryCounter - 1;
                }
                else
                {
                    finalmessage = "Inventory Full";
                }
            }
            else
            {
                finalmessage = "Cannot afford the item.";
            }
        }
        catch(NullPointerException npe)
        {
            finalmessage = ("Please select a different item.");
        }
        catch(IndexOutOfBoundsException ioobe)
        {
            finalmessage = ("Please select an item.");
        }
        
        return finalmessage;       
    }//</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="MOVEMENT and LOCATION and PLACES">
    public String move(String d)
    {
        String message = "";
        double x = heroLocation.getX();
        double y = heroLocation.getY();
        if(getHeroPlace().equals(""))
        {
            if(d.equals("N"))
            {
                boolean move = setLocationMove(x, (y-5));
                if (move)
                {
                  heroLocation.setLocation(x, (y-5));
                    message = "You have travelled north.";  
                }
                else
                {
                    message = "NB";
                    
                }
                
            }
            else if(d.equals("S"))
            {
                boolean move = setLocationMove(x, (y+5));
                if (move)
                {
                  message = "You have travelled south.";  
                  heroLocation.setLocation(x, (y+5));
                }
                else
                {
                    message = "SB";
                    
                }
            }
            else if(d.equals("W"))
            {
                boolean move = setLocationMove((x-5), y);
                if (move)
                {
                  message = "You have travelled west."; 
                  heroLocation.setLocation((x-5),y); 
                }
                else
                {
                    message = "WB";
                   
                }
            }
            else if(d.equals("E"))
            {
                boolean move = setLocationMove((x+5), y);
                if (move)
                {
                    heroLocation.setLocation((x+5), y);
                  message = "You have travelled east.";  
                }
                else
                {
                    message = "EB";
                    
                }
            }
        }
        else
        {
            if(d.equals("N"))
            {
                boolean move = setLocationMove(x, (y-15));
                if (move)
                {
                  message = "You have travelled north."; 
                  heroLocation.setLocation(x, (y-15));
                }
                else
                {
                    message = "NB";
                    
                }
            }
            else if(d.equals("S"))
            {
                boolean move = setLocationMove(x, (y+15));
                
                if (move)
                {
                  message = "You have travelled south."; 
                  heroLocation.setLocation(x, (y+15)); 
                }
                else
                {
                    message = "SB";
                    
                }
            }
            else if(d.equals("W"))
            {
                boolean move = setLocationMove((x-15), y);
                if (move)
                {
                  message = "You have travelled west.";  
                  heroLocation.setLocation((x-15),y);
                }
                else
                {
                    message = "WB";
                    
                }
            }
            else if(d.equals("E"))
            {
                boolean move = setLocationMove((x+15), y);
                if (move)
                {
                  message = "You have travelled east.";  
                  heroLocation.setLocation((x+15), y);  
                }
                else
                {
                    message = "EB";
                }
            }
        }
            
            setHeroPlace(getHeroPlace());
            
            
        return message;
    }
    
    public boolean setLocationMove(double x, double y)
        {
            boolean canGo = true;
            
            //Valpond Ocean Bottom
            if(((x >= 360 && x <= 430) && (y >= 225 && y <= 260)) || ((x >= 360 && x <= 610) && (y >= 260 && y <= 600)) || ((x >= 610 && x <= 800) && (y >= 260 && y <= 370)) || ((x >= 715 && x <= 800) && (y >= 370 && y <= 455)) || ((x >= 610 && x <= 800) && (y >= 455 && y <= 600)))
            {
                canGo = false;
            }
            //Valpond Ocean Top
            if(((x >= 360 && x <= 430) && (y >= 145 && y <= 195)))
            {
                canGo = false;
            }
            //Whitehold Desert
            if(((x >= 0 && x <= 205) && (y >= 435 && y <= 600)))
            {
                JOptionPane.showMessageDialog(null, "The road to this location is closed for construction. Sorry for the inconvenience.");
                canGo = false;
            }
            //Corcliff Mountains
            if(((x >= 0 && x <= 265) && (y >= 35 && y <= 145)))
            {
                JOptionPane.showMessageDialog(null, "The road to this location is closed for construction. Sorry for the inconvenience.");
                canGo = false;
            }
            //Coldoak Forest West
            if(((x >= 265 && x <= 555) && (y >= 0 && y <= 145)))
            {
                JOptionPane.showMessageDialog(null, "The road to this location is closed for construction. Sorry for the inconvenience.");
                canGo = false;
            }
            //Coldoak Forest East
            if(((x >= 555 && x <= 800) && (y >= 90 && y <= 145)))
            {
                JOptionPane.showMessageDialog(null, "The road to this location is closed for construction. Sorry for the inconvenience.");
                canGo = false;
            }

            return canGo;
        }
    
    public String getHeroPlace()
    {
        ArrayList<Village> villages = l.getVillageList();
        ArrayList<Town> towns = l.getTownList();
        ArrayList<City> cities = l.getCityList();
        String placename = "";
 
        for(Village v : villages)
        {
            Point z1 = v.getTopLeft();
            Point z2 = v.getBottomRight();
           
            if((heroLocation.getX() >= z1.getX() && heroLocation.getX() <= z2.getX()) && (heroLocation.getY() >= z1.getY() && heroLocation.getY() < z2.getY()))
            {
                placename = v.getName();
            }
        }
        
       for(Town t : towns)
        {
            Point z1 = t.getTopLeft();
            Point z2 = t.getBottomRight();
            
            
            if((heroLocation.getX() >= z1.getX() && heroLocation.getX() <= z2.getX()) && (heroLocation.getY() >= z1.getY() && heroLocation.getY() < z2.getY()))
            {
                placename = t.getName();
            }
        }
       
       for(City c : cities)
        {
            Point z1 = c.getTopLeft();
            Point z2 = c.getBottomRight();
            
            if((heroLocation.getX() >= z1.getX() && heroLocation.getX() <= z2.getX()) && (heroLocation.getY() >= z1.getY() && heroLocation.getY() < z2.getY()))
            {
                placename = c.getName();
            }
        }
        return placename;
    }
    
    public void setHeroPlace(String pn)
    {
        ArrayList<Village> villages = l.getVillageList();
        ArrayList<Town> towns = l.getTownList();
        ArrayList<City> cities = l.getCityList();
        String placename = "";
        if (!pn.equals(""))
        {
            for(Village v : villages)
            {
                if(v.getName().equals(pn))
                {
                    placename = v.getName();
                    heroLocation = v.getMiddlePoint();
                    v.setVisited(true);
                }
            }

           for(Town t : towns)
            {            
                if(t.getName().equals(pn))
                {
                    placename = t.getName();
                    heroLocation = t.getMiddlePoint();
                    t.setVisited(true);
                }
            }

           for(City c : cities)
            {
                if(c.getName().equals(pn))
                {
                    placename = c.getName();
                    heroLocation = c.getMiddlePoint();
                    c.setVisited(true);
                }
            }
           heroPlace = placename;
        }
    } //</editor-fold> 
    
}
